//	VirtualDub - Video processing and capture application
//	Copyright (C) 1998-2001 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef f_DUB_H
#define f_DUB_H

#include <windows.h>
#include <vector>

#include <vd2/system/error.h>
#include <vd2/system/vdalloc.h>
#include <vd2/system/VDString.h>
#include <vd2/system/fraction.h>
#include "audio.h"
#include "filters.h"
#include "fixes.h"
#include "AVIStripeSystem.h"
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, Feb 2003												***
// BEGIN **************************************************************
#include "DubInfo.h"
#include "ModList.h"
#include "ModStream.h"
#include "ModDubStream.h"
// Moved classes DubAudioOptions, DubVideoOptions, DubPerfOptions,
// DubOptions, DubStreamInfo, DubAudioStreamInfo, DubVideoStreamInfo
// in DubInfo.h
// END ****************************************************************

class AsyncBlitter;
class AVIPipe;
class AVIOutput;
class DubSource;
class AudioSource;
class IVDVideoSource;
class FrameSubset;
class InputFile;
class IDubStatusHandler;
class IVDDubberOutputSystem;
struct VDAudioFilterGraph;

////////////////////////

class IDubber {
public:
	virtual ~IDubber()					=0;

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, Feb 2003												***
// BEGIN **************************************************************
	virtual void SetInputFile(InputFile *)=0;
	virtual void SetPhantomVideoMode()=0;
	virtual void SetInputDisplay(IVDVideoDisplay *pDisplay) = 0;
	virtual void SetOutputDisplay(IVDVideoDisplay *pDisplay) = 0;
	virtual void EnableSpill(__int64 size, long lFrameLimit)=0;
	virtual void Init(ModVideoStream& videoStream, ModList<ModDubStream>& streams, IVDDubberOutputSystem *out, COMPVARS *videoCompVars) = 0;
// END ****************************************************************
	virtual void Go(int iPriority = 0) = 0;
	virtual void Stop() = 0;

	virtual void RealizePalette()	=0;
	virtual void Abort()			=0;
	virtual bool isRunning()		=0;
	virtual bool isAbortedByUser()	=0;
	virtual bool IsPreviewing()		=0;

	virtual void SetStatusHandler(IDubStatusHandler *pdsh)		=0;
	virtual void SetPriority(int index)=0;
	virtual void UpdateFrames()=0;
};

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, Feb 2003												***
// BEGIN **************************************************************
IDubber *CreateDubber(DubOptions *xopt, bool bHandleVBR=false, uint32 outputFormat=SOURCE_AVI);
void InitStreamValuesStatic(DubVideoStreamInfo& vInfo, DubAudioStreamInfo& aInfo, IVDVideoSource *video, AudioSource *audio, DubOptions *opt, FrameSubset *pfs=NULL);
void InitStreamValuesStatic(DubVideoStreamInfo& vInfo, ModVideoStream& videoStream, ModList<ModDubStream>& streams, DubOptions *opt, FrameSubset *pfs=NULL, bool bPreview=false);
// END ****************************************************************

#ifndef f_DUB_CPP

extern DubOptions g_dubOpts;
#endif

#endif
