/*
 * Copyright (c) 2002 Milan Cutka
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

// ************************************************************************
// *** Wrapper for dynamically loading OpenGL.dll						***
// *** Tobias Minich, May 2003											***
// ************************************************************************


#include "stdafx.h"
#include "COpenGL.h"
#include "Tdll.h"

using namespace std;

COpenGL::COpenGL() : Tdll("OpenGL32.dll", NULL)
{
	loadFunction((void**)&wglDeleteContext,"wglDeleteContext");
	loadFunction((void**)&wglMakeCurrent,"wglMakeCurrent");
	loadFunction((void**)&wglCreateContext,"wglCreateContext");
	loadFunction((void**)&wglGetCurrentDC,"wglGetCurrentDC");
	loadFunction((void**)&wglGetProcAddress,"wglGetProcAddress");
	loadFunction((void**)&wglUseFontOutlines,"wglUseFontOutlinesA");

	loadFunction((void**)&glBegin,"glBegin");
	loadFunction((void**)&glBindTexture,"glBindTexture");
	loadFunction((void**)&glBlendFunc,"glBlendFunc");
	loadFunction((void**)&glCallLists,"glCallLists");
	loadFunction((void**)&glClear,"glClear");
	loadFunction((void**)&glClearColor,"glClearColor");
	loadFunction((void**)&glColor3fv,"glColor3fv");
	loadFunction((void**)&glColor4f,"glColor4f");
	loadFunction((void**)&glCullFace,"glCullFace");
	loadFunction((void**)&glDeleteLists,"glDeleteLists");
	loadFunction((void**)&glDeleteTextures,"glDeleteTextures");
	loadFunction((void**)&glDisable,"glDisable");
	loadFunction((void**)&glEnable,"glEnable");
	loadFunction((void**)&glEnd,"glEnd");
	loadFunction((void**)&glFlush,"glFlush");
	loadFunction((void**)&glGenTextures,"glGenTextures");
	loadFunction((void**)&glGetString,"glGetString");
	loadFunction((void**)&glHint,"glHint");
	loadFunction((void**)&glListBase,"glListBase");
	loadFunction((void**)&glLoadIdentity,"glLoadIdentity");
	loadFunction((void**)&glMatrixMode,"glMatrixMode");
	loadFunction((void**)&glPopMatrix,"glPopMatrix");
	loadFunction((void**)&glPushMatrix,"glPushMatrix");
	loadFunction((void**)&glRotatef,"glRotatef");
	loadFunction((void**)&glScalef,"glScalef");
	loadFunction((void**)&glTexCoord2f,"glTexCoord2f");
	loadFunction((void**)&glTexEnvi,"glTexEnvi");
	loadFunction((void**)&glTexParameteri,"glTexParameteri");
	loadFunction((void**)&glTranslatef,"glTranslatef");
	loadFunction((void**)&glVertex3f,"glVertex3f");
	loadFunction((void**)&glVertex3fv,"glVertex3fv");
	loadFunction((void**)&glViewport,"glViewport");
}


COpenGL::~COpenGL()
{

}

