// ************************************************************************
// *** Wrapper for dynamically loading OpenGL.dll						***
// *** Tobias Minich, May 2003											***
// ************************************************************************


#ifndef _COPENGL_H_
#define _COPENGL_H_

#include <gl/gl.h>
#include "Tdll.h"

class COpenGL : public Tdll {
	private:
	protected:
	public:
		BOOL (WINAPI *wglDeleteContext)(HGLRC);
		BOOL (WINAPI *wglMakeCurrent)(HDC, HGLRC);
		HGLRC (WINAPI *wglCreateContext)(HDC);
		HDC (WINAPI *wglGetCurrentDC)(VOID);
		PROC (WINAPI *wglGetProcAddress)(LPCSTR);
		BOOL (WINAPI *wglUseFontOutlines)(HDC, DWORD, DWORD, DWORD, FLOAT,
                                           FLOAT, int, LPGLYPHMETRICSFLOAT);

		void (APIENTRY *glBegin) (GLenum mode);
		void (APIENTRY *glBindTexture) (GLenum target, GLuint texture);
		void (APIENTRY *glBlendFunc) (GLenum sfactor, GLenum dfactor);
		void (APIENTRY *glCallLists) (GLsizei n, GLenum type, const GLvoid *lists);
		void (APIENTRY *glClear) (GLbitfield mask);
		void (APIENTRY *glClearColor) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
		void (APIENTRY *glColor3fv) (const GLfloat *v);
		void (APIENTRY *glColor4f) (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
		void (APIENTRY *glCullFace) (GLenum mode);
		void (APIENTRY *glDeleteLists) (GLuint list, GLsizei range);
		void (APIENTRY *glDeleteTextures) (GLsizei n, const GLuint *textures);
		void (APIENTRY *glDisable) (GLenum cap);
		void (APIENTRY *glEnable) (GLenum cap);
		void (APIENTRY *glEnd) (void);
		void (APIENTRY *glFlush) (void);
		void (APIENTRY *glGenTextures) (GLsizei n, GLuint *textures);
		const GLubyte * (APIENTRY *glGetString) (GLenum name);
		void (APIENTRY *glHint) (GLenum target, GLenum mode);
		void (APIENTRY *glListBase) (GLuint base);
		void (APIENTRY *glLoadIdentity) (void);
		void (APIENTRY *glMatrixMode) (GLenum mode);
		void (APIENTRY *glPopMatrix) (void);
		void (APIENTRY *glPushMatrix) (void);
		void (APIENTRY *glRotatef) (GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
		void (APIENTRY *glScalef) (GLfloat x, GLfloat y, GLfloat z);
		void (APIENTRY *glTexCoord2f) (GLfloat s, GLfloat t);
		void (APIENTRY *glTexEnvi) (GLenum target, GLenum pname, GLint param);
		void (APIENTRY *glTexParameteri) (GLenum target, GLenum pname, GLint param);
		void (APIENTRY *glTranslatef) (GLfloat x, GLfloat y, GLfloat z);
		void (APIENTRY *glVertex3f) (GLfloat x, GLfloat y, GLfloat z);
		void (APIENTRY *glVertex3fv) (const GLfloat *v);
		void (APIENTRY *glViewport) (GLint x, GLint y, GLsizei width, GLsizei height);

		COpenGL();
		virtual ~COpenGL();

};

#endif
