//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __CORONAFILEWRAPPER_H__
#define __CORONAFILEWRAPPER_H__

#include <vd2/system/VDString.h>
#include <vd2/system/File64.h>
#include "corona.h"

class CoronaFile : public corona::DLLImplementation<corona::File> {
protected:
	VDFile		*m_File;

public:
	CoronaFile(void);
	CoronaFile(VDFile& file);
	void close(void);
	bool isOpen(void);

	int COR_CALL	read(void *buffer, int length);
	int COR_CALL	write(const void *buffer, int length);
	bool COR_CALL	seek(int position, SeekMode mode);
	int COR_CALL	tell(void);
};

#endif // __CORONAFILEWRAPPER_H__