//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __ISO639_H__
#define __ISO639_H__


struct ISO639_Language {
	wchar_t	*m_EnglishName;
	wchar_t	*m_ISO639_2_Code;
	wchar_t	*m_ISO639_1_Code;
};

extern ISO639_Language s_LanguageList[];

bool	ISO639_IsValidIndex_1(sint32 index);
bool	ISO639_IsValidIndex_2(sint32 index);
sint32	ISO639_GetRootIndex(sint32 index);
wchar_t	*ISO639_GetEnglishName(sint32 index);
wchar_t	*ISO639_GetEnglishName_1(const wchar_t *ISO639_1_Code);
wchar_t	*ISO639_GetEnglishName_2(const wchar_t *ISO639_2_Code);
sint32	ISO639_GetIndex(const wchar_t *ISO639_EnglishName);
sint32	ISO639_GetIndex_1(const wchar_t *ISO639_1_Code);
sint32	ISO639_GetIndex_2(const wchar_t *ISO639_2_Code);
sint32	ISO639_GetNearestIndex(const wchar_t *ISO639_EnglishName);

#endif // __ISO639_H__