//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __MODAUDIOSTREAMSOURCEAC3_H__
#define __MODAUDIOSTREAMSOURCEAC3_H__

#include "AudioSource.h"
#include "Audio.h"
#include "ModAudioSourceAC3.h"

extern "C" {
	// liba52 headers
	#ifdef LIBA52_DOUBLE
		#undef LIBA52_DOUBLE    // ensure floats
	#endif
	#include "liba52/inttypes.h"
	#include "liba52/a52.h"
	#include "liba52/a52_internal.h"
	#include "liba52/mm_accel.h"
}

class ModAudioStreamSourceAC3 : public AudioStream {
protected:
	AudioSource *m_Source;
	long		cur_samp;
	long		end_samp;
	bool		m_bSourceEOS;
	long		m_BlockAlign;
	long		m_SourceBlockAlign;
	long		m_SourceRate;
	long		m_SourceScale;
	bool		m_bSeemsVBR;
	long		m_BlankSamples;
	a52_state_t	*a52state;
	char		m_InputBuffer[4*AC3_MAX_LENGTH];
	char		m_OutputBuffer[AC3_SAMPLESPERFRAME*2*2];
	char		*m_OutputBufferPos;
	long		m_BytesInOutputBuffer;
	long		m_BytesInInputBuffer;
	long		m_LastFrameLength;

	bool		GetNextFrame(bool bDecode, bool bSkip=false);
	bool		ReadSource(long bytes);

public:
	ModAudioStreamSourceAC3(AudioSource *source, long first_sample, long max_samples);
	virtual ~ModAudioStreamSourceAC3(void);

	long _Read(void *buffer, long max_samples, long *lplBytes);
	bool Skip(long samples);
	BOOL _isEnd();
};

#endif // __MODAUDIOSTREAMSOURCEAC3_H__