//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __MODAUDIOSTREAMSOURCEMP3_H__
#define __MODAUDIOSTREAMSOURCEMP3_H__

#include <vd2/Priss/decoder.h>
#include "AudioSource.h"
#include "Audio.h"
#include "ModAudioSourceMP3.h"

class ModAudioStreamSourceMP3 : public AudioStream, public IAMPBitsource {
protected:
	AudioSource *m_Source;
	IAMPDecoder	*iad;
	long		cur_samp;
	long		end_samp;
	bool		m_bSourceEOS;
	long		m_SamplesPerFrame;
	long		m_BlockAlign;
	long		m_SourceBlockAlign;
	long		m_SourceRate;
	long		m_SourceScale;
	bool		m_bSeemsVBR;
	long		m_BlankSamples;
	char		m_InputBuffer[4*MPA_MAX_LENGTH];
	char		m_OutputBuffer[1152*2*2];
	char		*m_OutputBufferPos;
	long		m_BytesInOutputBuffer;
	long		m_BytesInInputBuffer;
	int			m_BytesSent;
	int			m_DecodeStart;
	bool		m_bNandubVBR;

	bool		GetNextFrame(bool bDecode, bool bSkip=false);
	bool		ReadSource(long bytes);

public:
	ModAudioStreamSourceMP3(AudioSource *source, long first_sample, long max_samples);
	virtual ~ModAudioStreamSourceMP3(void);

	long _Read(void *buffer, long max_samples, long *lplBytes);
	bool Skip(long samples);
	BOOL _isEnd();

	int read(void *buffer, int bytes);
};

#endif // __MODAUDIOSTREAMSOURCEMP3_H__