//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __MODFILESELECTCONTROL_H__
#define __MODFILESELECTCONTROL_H__

#include "commctrl.h"
#include <vector>
#include <list>
#include <map>
#include <string>
#include <tchar.h>


typedef std::basic_string<TCHAR>	tcstring;

//////////////////////////////////////////////////////////////////////

ATOM RegisterModFileSelectControl(void);

class ModFileSelectControl {
public:
	// ctor/dtor
	ModFileSelectControl(HWND hWnd);
	virtual ~ModFileSelectControl(void);

	HWND	GetWindow(void);
	HFONT	GetFont(void);
	HFONT	SetFont(HFONT hFont, BOOL bRedraw);
	LPCTSTR	GetFileName(void);
	void	SetFileName(LPCTSTR szFileName);
	void	SetFilters(LPCTSTR szFilters);

	// static functions
	static LRESULT CALLBACK	StaticWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
	static ModFileSelectControl	*Create(HWND hwndParent, int x, int y, int cx, int cy, UINT id);

protected:
	HWND	m_hWnd;
	HWND	m_hEditBox;
	HWND	m_hButton;
	tcstring	m_FileName;
	LPCTSTR	m_Filters;

	LRESULT	WndProc(UINT msg, WPARAM wParam, LPARAM lParam);
	bool	Init(void);
};

ModFileSelectControl *GetModFileSelectControl(HWND hwnd);

#endif // __MODFILESELECTCONTROL_H__