//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __MODSTREAMSSETUP_H__
#define __MODSTREAMSSETUP_H__

#include <windows.h>

#include <vd2/system/VDString.h>
#include <vd2/system/vdtypes.h>
#include "ModStream.h"

extern ModList<ModStream>	g_Streams;
extern ModVideoStream		g_VideoStream;

void ModDisplayStreamListDialog(VDGUIHandle hwndParent);

bool OpenModInputFile(VDStringW fileName, uint32 type, sint64 offset, bool bRetrieveComments, bool bShutUp, bool bRetrieveOffset);
void AddModInputStreams(bool bRetrieveComments, bool bRetrieveOffset);
sint32 AddModInputStream(DWORD fccType, LONG index, sint64 offset, bool bRetrieveComments, bool bShutUp, bool bRetrieveOffset);
sint32 AddModInputStream(LONG index, sint64 offset, bool bRetrieveComments, bool bShutUp, bool bRetrieveOffset);
void RemoveModStreams(void);
void ClearVideoStream(void);
void CloseModInputFiles(void);
void PrepareRefreshModInputStreams(void);
void RefreshModInputStreams(void);
void RefreshStreamsComments(void);

BOOL APIENTRY ShowStreamsReportDlgProc( HWND hDlg, UINT message, UINT wParam, LONG lParam);

void ModDisplayStreamCommentsDialog(VDGUIHandle hwndParent, ModList<ModStreamComment>& comments);
void ModDisplayStreamChaptersDialog(VDGUIHandle hwndParent, ModChapterList& chapters);

void ModEnumVideoModes(void (__cdecl *enumFunctionCB)(int iID, LPCTSTR szValue, UINT iState, void *pData), void *pData);
void PopulateComboBoxWithVideoModes(HWND hComboBox, int iVideoMode);
void SaveAs(HWND hWnd);

BOOL CALLBACK VideoJumpLastKeyDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
sint64 PositionFilePositionCallback(HWND hwnd, void *pvData, long pos);
long JumpToLastKeyBeforePos(sint64 pos);

void ForceDirectStreamCopy(bool bForce);

#endif // __MODSTREAMSSETUP_H__