//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __MODTEXTSOUCESRT_H__
#define __MODTEXTSOUCESRT_H__

#include <vd2/system/File64.h>
#include <vd2/system/VDString.h>
#include "AudioSource.h"
#include "ModList.h"
#include "ModClassInterfaces.h"
#include "ModTextSource.h"
#include "ModTextUtil.h"


class ModTextSourceSRT : public AudioSource, public ISubtitleHandler {
protected:
	ModTextSource	m_TextSource;
	eTextType		m_TextType;
	sint32 m_LastSubtitleEndMS;
	ModSubtitleProvider	m_SubtitleProvider;
	VDStringW		m_FileErrors;

	bool getTimes(VDStringW line, sint32& startMS, sint32& durationMS, bool& overlapping);

public:
	ModTextSourceSRT(const wchar_t *szFileName);
	virtual ~ModTextSourceSRT(void);
	virtual bool init();
	virtual sint32 samplesLag(sint64 lStart) { return 0; };
	virtual int _read(LONG lStart, LONG lCount, LPVOID lpBuffer, LONG cbBuffer, LONG *lBytesRead, LONG *lSamplesRead);

	VDStringW	writeReport(void);

	bool QueryInterface(InterfaceID ID, void** destination);
	bool IsASCII(void);
	bool HasBOM(void);
	eTextType GetOutputType(void);
	ModSubtitleProvider *GetSubtitleProvider(void);
};

#endif // __MODTEXTSOUCESRT_H__