//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __SRTOUTPUTFILE_H__
#define __SRTOUTPUTFILE_H__

#include "AVIOutput.h"
#include "ModTextSource.h"
#include "ModTextUtil.h"


class SRTOutputFile;

class SRTOutputStream : public AVIOutputStream, IOverlappingOutput {
protected:
	SRTOutputFile	*m_Parent;
	//eTextType	m_InputInType;
	eTextType	m_OutputInType;
	ModTextUtil	m_TextUtil;
	uint64		m_SamplesProcessed;
	uint32		m_SubtitleIndex;

	VDStringW	_getSubtitle(LPVOID lpBuffer, LONG cbBuffer);

public:
	SRTOutputStream(SRTOutputFile *parent, eTextType inputType=kTextType_ASCII, eTextType outputType=kTextType_UTF16LE);
	void write(uint32 flags, const void *pBuffer, uint32 cbBuffer, uint32 samples);
	BOOL finalize(void);
	void setEndOfStream(void);
	void setStreamLag(sint32 samplesLag);

	bool QueryInterface(InterfaceID ID, void** destination);
	BOOL WriteData(LONG dwIndexFlags, LPVOID lpBuffer, LONG cbBuffer, LONG lSampleStart, LONG lSampleCount);
};

class SRTOutputFile : public AVIOutput {
protected:
	static char szME[];
	VDFile		m_File;
	HANDLE		m_hFile;
	eTextType	m_InputInType;
	eTextType	m_OutputInType;
	bool		m_bWriteBOM;

public:
	SRTOutputFile(eTextType outputType=kTextType_UTF16LE, bool bWriteBOM=true);
	virtual ~SRTOutputFile(void);

	IVDMediaOutputStream *createVideoStream();
	IVDMediaOutputStream *createAudioStream();
	bool initOutputStreams(ModVideoStream& videoStream, ModList<ModDubStream>& streams);
	IVDMediaOutputStream *getOutputStream(uint32 serial);
	bool init(const wchar_t *szFile);
	void finalize(void);

	void write(const void *pBuffer, uint32 cbBuffer);
};

#endif // __SRTOUTPUTFILE_H__