//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __SRTOUTPUTFILESYTEM_H__
#define __SRTOUTPUTFILESYTEM_H__

#include "DubOutput.h"
#include "ModTextSource.h"


class SRTOutputFileSystem : public IVDDubberOutputSystem {
protected:
	VDStringW				mFilename;
	AVIStreamHeader_fixed	mAudioStreamInfo;
	std::vector<char>		mAudioFormat;
	ModDubStream			*m_Stream;
	eTextType				m_OutputInType;
	bool					m_bWriteBOM;

public:
	SRTOutputFileSystem(const wchar_t *pszFilename, eTextType outputFormat=kTextType_UTF16LE, bool bWriteBOM=true);
	void SetVideo(ModVideoStream& stream, const AVIStreamHeader_fixed& asi, const void *pFormat, int cbFormat);
	void AddStream(ModDubStream& stream, const AVIStreamHeader_fixed&, const void *pFormat, int cbFormat, bool bInterleaved);
	bool AcceptsText();

	AVIOutput *CreateSegment();
	void CloseSegment(AVIOutput *pSegment, bool bLast);
	void SetVideo(const AVIStreamHeader_fixed& asi, const void *pFormat, int cbFormat);
	void SetAudio(const AVIStreamHeader_fixed& asi, const void *pFormat, int cbFormat, bool bInterleaved);
	bool AcceptsVideo();
	bool AcceptsAudio();
	bool IsRealTime() { return false; }
};

#endif // __SRTOUTPUTFILESYTEM_H__