//	VirtualDubMod - Video processing and capture application
//	Based on VirtualDub Copyright (C) 1998-2001 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef f_LOG_HANDLING_H
#define f_LOG_HANDLING_H

typedef struct
{
/* frame length (bytes) */

DWORD bytes;

/* ignored & zero'd by gk
xvid specific: dk_v = frame header bytes
*/

int dk_v, dk_u, dk_y;
int dd_v, dd_u, dd_y;
int mk_u, mk_y;
int md_u, md_y;

/* q used for this frame
set bit 31 for keyframe */

int quant;

/* key, motion, not-coded macroblocks */

int kblk, mblk, ublk;

/* lum_noise is actually a double (as 8 bytes)
for some reason msvc6.0 stores doubles as 12 bytes!?
lum_noise is not used so it doesnt matter */

float lum_noise[2];
} NNSTATS, *LPNNSTATS; 

#define NNSTATS_KEYFRAME (1<<31) 

#endif
