//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __MODAUDIOSTREAMSOURCEVORBIS_H__
#define __MODAUDIOSTREAMSOURCEVORBIS_H__

#include <ogg/ogg.h>
#include <vorbis/codec.h>
#include "AudioSource.h"
#include "Audio.h"
#include "ModAudioSourceAC3.h"


class ModAudioStreamSourceVorbis : public AudioStream {
protected:
	AudioSource *m_Source;
	long		cur_samp;
	long		end_samp;
	vorbis_info			m_VorbisInfo;
	vorbis_comment		m_VorbisComment;
	vorbis_dsp_state	m_VorbisDSP;
	vorbis_block		m_VorbisBlock;
	ogg_packet			m_Packet;
	bool		m_bDecoderInitialized;
	bool		m_bSourceEOS;
	long		m_BlockAlign;
	long		m_SourceRate;
	long		m_SourceScale;
	long		m_BlankSamples;
	char		m_InputBuffer[0xFFFF];
	float		**m_PCMBuffer;
	long		m_PCMBufferPos;
	long		m_SamplesInPCMBuffer;
	long		m_SamplesLeftInPCMBuffer;

	bool		GetNextFrame(void);
	bool		ReadSource(void);

public:
	ModAudioStreamSourceVorbis(AudioSource *source, long first_sample, long max_samples);
	virtual ~ModAudioStreamSourceVorbis(void);

	long _Read(void *buffer, long max_samples, long *lplBytes);
	bool Skip(long samples);
	BOOL _isEnd();
};

#endif // __MODAUDIOSTREAMSOURCEVORBIS_H__