//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __OGGCOMENTS_H__
#define __OGGCOMENTS_H__

#include "ModStream.h"

using namespace nsModStream;

static struct {
	eCommentType	m_Type;
	wchar_t			*m_Tag;
} s_OggCommentTypesTable[] = {
//	{	cSoftware,		L"ENCODER"},
	{	cTitle,			L"TITLE"},
	{	cDescription,	L"DESCRIPTION"},
	{	cLanguage,		L"LANGUAGE"},
	{	cAuthor,		L"ARTIST"},
	{	cCopyright,		L"COPYRIGHT"},
	{	cLicense,		L"LICENSE"},
	{	cGenre,			L"GENRE"},
	{	cDate,			L"DATE"},
	{	cVersion,		L"VERSION"},
	{	cPerformer,		L"PERFORMER"},
	{	cAlbum,			L"ALBUM"},
	{	cTrackNumber,	L"TRACKNUMBER"},
	{	cOrganisation,	L"ORGANIZATION"},
	{	cLocation,		L"LOCATION"},
	{	cContact,		L"CONTACT"},
	{	cISRC,			L"ISRC"},
	{	cVoid,			NULL}
};

bool GetOggCommentType(const wchar_t *tag, eCommentType& type);
const wchar_t *GetOggCommentTag(eCommentType type);

#endif // __OGGCOMENTS_H__