//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2003 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"

#include "CoronaFileWrapper.h"

CoronaFile::CoronaFile(void)
: m_File(NULL) {
}

CoronaFile::CoronaFile(VDFile& file)
: m_File(&file) {
}

void CoronaFile::close(void) {
	VDASSERT(m_File);
	if(isOpen())
		m_File->close();
}

bool CoronaFile::isOpen(void) {
	return (m_File && m_File->isOpen());
}

int COR_CALL CoronaFile::read(void *buffer, int length) {
	VDASSERT(m_File);
	return m_File->readData(buffer, length);
}

int COR_CALL CoronaFile::write(const void *buffer, int length) {
	VDASSERT(m_File);
	return m_File->writeData(buffer, length);
}

bool COR_CALL CoronaFile::seek(int position, SeekMode mode) {
	VDASSERT(m_File);
	switch(mode) {
	case corona::File::SeekMode::BEGIN:		return m_File->seekNT(position, nsVDFile::kSeekStart);
	case corona::File::SeekMode::CURRENT:	return m_File->seekNT(position, nsVDFile::kSeekCur);
	case corona::File::SeekMode::END:		return m_File->seekNT(position, nsVDFile::kSeekEnd);
	}
	return false;
}

int COR_CALL CoronaFile::tell(void) {
	VDASSERT(m_File);
	return m_File->tell();
}
