#include "stdafx.h"

#include <windows.h>

#include <vd2/system/error.h>
#include "VideoSourceImages.h"
#include "InputFileImages.h"
// ************************************************************************
// *** VirtualDubMod													***
// *** Tobias Minich, Apr 2003											***
// BEGIN ******************************************************************
#include "gui.h"
#include "resource.h"
// END ********************************************************************

extern const char g_szError[];

InputFileImages::InputFileImages()
{
}

InputFileImages::~InputFileImages() {
}

void InputFileImages::Init(const wchar_t *szFile) {
	videoSrc = new VideoSourceImages(VDTextWToA(szFile).c_str());
}

void InputFileImages::setOptions(InputFileOptions *_ifo) {
}

InputFileOptions *InputFileImages::createOptions(const char *buf) {
	return NULL;
}

InputFileOptions *InputFileImages::promptForOptions(HWND hwnd) {
	return NULL;
}

void InputFileImages::setAutomated(bool fAuto) {
}

void InputFileImages::InfoDialog(HWND hwndParent) {
	guiMessageBox(hwndParent, IDS_ERR_NOINFO_IMAGESEQ, IDS_ERR_CAPTION, MB_OK);
}

///////////////////////////////////////////////////////////////////////////

class VDInputDriverImages : public vdrefcounted<IVDInputDriver> {
public:
	const wchar_t *GetSignatureName() { return L"Image sequence input driver (internal)"; }

	int GetDefaultPriority() {
		return -1;
	}

	uint32 GetFlags() { return kF_Video; }

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, March 2003											***
// BEGIN **************************************************************
	const wchar_t *GetFilenamePattern() {
		return L"Image sequence (*.bmp,*.tga,*.png,*.jpg,*.gif,*.pcx)\0*.bmp;*.tga;*.png;*.jpg;*.gif;*.pcx\0";
	}

	bool DetectByFilename(const wchar_t *pszFilename) {
		size_t l = wcslen(pszFilename);

		if (l>4 && !wcsicmp(pszFilename + l - 4, L".tga"))
			return true;

		if (l>4 && !wcsicmp(pszFilename + l - 4, L".png"))
			return true;

		if (l>4 && !wcsicmp(pszFilename + l - 4, L".jpg"))
			return true;

		if (l>4 && !wcsicmp(pszFilename + l - 4, L".gif"))
			return true;

		if (l>4 && !wcsicmp(pszFilename + l - 4, L".pcx"))
			return true;

		return false;
	}

	int DetectBySignature(const void *pHeader, sint32 nHeaderSize, const void *pFooter, sint32 nFooterSize, sint64 nFileSize) {
		const uint8 *buf = (const uint8 *)pHeader;

		if (nHeaderSize >= 32) {
			if (buf[0] == 'B' && buf[1] == 'M')
				return 1;
		}

		if (nFooterSize > 18) {
			if (!memcmp((const uint8 *)pFooter + nFooterSize - 18, "TRUEVISION-XFILE.", 18))
				return 1;
		}

		if (nHeaderSize >= 4) {
			if(!memcmp(buf+1, "PNG", 3))
				return 1;		// <-- PNG file

			if(!memcmp(buf, "GIF", 3))
				return 1;		// <-- GIF file

			if( (*(long *)(buf+0) == 0xE0FFD8FF) && !memcmp(buf+6, "JFIF", 5) )
				return 1;		// <-- JPEG file
		}
		return -1;
	}
// END ****************************************************************

	InputFile *CreateInputFile(uint32 flags) {
		return new InputFileImages;
	}
};

extern IVDInputDriver *VDCreateInputDriverImages() { return new VDInputDriverImages; }
