//	VirtualDub - Video processing and capture application
//	Copyright (C) 1998-2001 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"

#define f_PREFS_CPP

#include <windows.h>
#include <commctrl.h>

#include "resource.h"
#include "helpfile.h"

#include "gui.h"
#include "oshelper.h"
#include "dub.h"
#include "dubstatus.h"
#include "prefs.h"
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, March 2003											***
// BEGIN **************************************************************
#include "ModStreamsSetup.h"
#include "ModTreeControl.h"
#include "misc.h"
#include "projectui.h"
// END ****************************************************************
// *******************************************************************
// *** VirtualDubMod											   ***
// *** Tobias Minich, November 2002								   ***
// BEGIN *************************************************************
#include "accel.h"
#include "I18N.h"

extern ACCELKEYTABLE_AVS g_accelAVS;
extern WORD g_accelAVSCommand[VDM_ACCEL_AVS_COUNT];
extern char g_accelAVSDescription[VDM_ACCEL_AVS_COUNT][255];

extern ACCELKEYTABLE_CAPTURE g_accelCapture;
extern WORD g_accelCaptureCommand[VDM_ACCEL_CAPTURE_COUNT];
extern char g_accelCaptureDescription[VDM_ACCEL_CAPTURE_COUNT][255];

extern ACCELKEYTABLE_MAIN g_accelMain;
extern WORD g_accelMainCommand[VDM_ACCEL_MAIN_COUNT];
extern char g_accelMainDescription[VDM_ACCEL_MAIN_COUNT][255];

extern ACCELKEYTABLE_AUDIO g_accelAudio;
extern WORD g_accelAudioCommand[VDM_ACCEL_AUDIO_COUNT];
extern char g_accelAudioDescription[VDM_ACCEL_AUDIO_COUNT][255];

extern char g_accelKEYDescription[256][255];
extern WORD g_accelKEYKeycode[256];

static char g_szKeytableAVS[]="Keytable AVS";
static char g_szKeytableCapture[]="Keytable Capture";
static char g_szKeytableMain[]="Keytable Main";
static char g_szKeytableAudio[]="Keytable Audio";

extern HACCEL g_hAccelAVS;
extern HACCEL g_hAccelMain;
extern HACCEL g_hAccelAudio;

extern HWND g_hWnd;

//extern WORD g_accelAVSCommand[];
extern vdautoptr<VDProjectUI> g_projectui;

extern DubOptions g_dubOpts;
char g_szPerformanceOptions[]="Performance Options";

// END ***************************************************************

extern HINSTANCE g_hInst;

Preferences g_prefs={
	{ 0, PreferencesMain::DEPTH_FASTEST, 0, TRUE, 0 },
	{ 50*16, 4*16 },
};

static char g_szMainPrefs[]="Main prefs";

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, April 2003											***
// BEGIN **************************************************************
VDubModPreferences g_VDMPrefs = {
	FALSE,	// rewrite VBR headers with CBR values
	FALSE,	// don't really pay attention to AC3/DTS frame boundaries for AVI
	1,		// pack as many frames as necessary when muxing
	TRUE,	// keep corrupted data in MP3/AC3/DTS files
	500,	// default preload set to 500ms
	TRUE,	// disable preload for non AVI outputs
	FALSE,	// Well actually Priss rocks :p
	DubVideoOptions::M_FULL,	// default video mode : Full processing
	TRUE,	// show input video
	TRUE,	// show output video
// *************************************************
// BEGIN : Stone-D, 26/04/2003, Window Auto-Resizing
	FALSE,	// don't auto-resize / center
// END   : Stone-D, 26/04/2003, Window Auto-Resizing
// *************************************************
	250,	// limit of 250 (kB or frames) for rec lists
	0,		// don't use AVI 'rec ' lists
	FALSE,	// Script editor in multi-instance mode by default
	FALSE,	// Script editor doesn't automatically popup
};

static char g_szVDubModPrefs[] = "VDubMod prefs";

MatroskaPreferences g_MKVPrefs = {
	1000,	// limit clusters to 1000ms
	TRUE,	// Enable lacing
	1,		// Index only I frames in KaxCues
	TRUE,	// Index only video in KaxCues
	TRUE,	// Index the clusters in KaxSeekHead
	FALSE,	// Set the previous cluster isze on each cluster
	FALSE,	// Slower access (Cluster position), requires less memory
};

static char g_szMatroskaPrefs[] = "Matroska prefs";
// END ****************************************************************

// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
/*AVSPreferences g_AVSprefs={
	FALSE
};

static char g_szAVSPrefs[]="AVS prefs";

extern HACCEL g_hAccelMain;*/
// END ***************************************************************

////////////////////////////////////////////////////////////////

typedef struct PrefsDlgData {
	Preferences prefs;
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, April 2003											***
// BEGIN **************************************************************
	VDubModPreferences	m_VDMPrefs;
	MatroskaPreferences	m_MKVPrefs;
// END ****************************************************************
// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
//	AVSPreferences AVSprefs;
	ACCELKEYTABLE_AVS KeytableAVS;
	ACCELKEYTABLE_CAPTURE KeytableCapture;
	ACCELKEYTABLE_MAIN KeytableMain;
	ACCELKEYTABLE_AUDIO KeytableAudio;
	char LanguageDLL[MAX_PATH];
// END ***************************************************************

	HWND hwndDisplay;
	RECT rcTab;
} PrefsDlgData;

static void PreferencesChildPosition(HWND hWnd, PrefsDlgData *pdd) {
	SetWindowPos(hWnd, HWND_TOP, pdd->rcTab.left, pdd->rcTab.top, 0, 0, SWP_NOSIZE);
}

static BOOL APIENTRY PreferencesMainDlgProc( HWND hDlg, UINT message, UINT wParam, LONG lParam) {
	static char *szDepths[]={
		"Fastest (16-bit)",
		"Use output setting",
		"Match display depth",
		"16-bit (HiColor)",
		"24-bit (TrueColor)",
	};

	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hDlg, DWL_USER);
	HWND hwndItem;
	int i;

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hDlg, (PrefsDlgData *)lParam);
			SetWindowLong(hDlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////

			hwndItem = GetDlgItem(hDlg, IDC_OUTPUT_DEPTH);
			for(i=0; i<5; i++)
				SendMessage(hwndItem, CB_ADDSTRING, 0, (LPARAM)szDepths[i]);

			SendMessage(hwndItem, CB_SETCURSEL, pdd->prefs.main.iPreviewDepth, 0);


			hwndItem = GetDlgItem(hDlg, IDC_PREVIEW_PRIORITY);
			SendMessage(hwndItem, CB_ADDSTRING, 0, (LPARAM)"Default");
			for(i=0; i<8; i++)
				SendMessage(hwndItem, CB_ADDSTRING, 0, (LPARAM)g_szDubPriorities[i]);

			SendMessage(hwndItem, CB_SETCURSEL, pdd->prefs.main.iPreviewPriority, 0);

			hwndItem = GetDlgItem(hDlg, IDC_DUB_PRIORITY);
			SendMessage(hwndItem, CB_ADDSTRING, 0, (LPARAM)"Default");
			for(i=0; i<8; i++)
				SendMessage(hwndItem, CB_ADDSTRING, 0, (LPARAM)g_szDubPriorities[i]);

			SendMessage(hwndItem, CB_SETCURSEL, pdd->prefs.main.iDubPriority, 0);

			//////////////

			CheckDlgButton(hDlg, IDC_TACK_EXTENSION, pdd->prefs.main.fAttachExtension);
			return TRUE;

		case WM_DESTROY:
			pdd->prefs.main.iPreviewDepth = (char)SendDlgItemMessage(hDlg, IDC_OUTPUT_DEPTH, CB_GETCURSEL, 0, 0);
			pdd->prefs.main.iPreviewPriority = (char)SendDlgItemMessage(hDlg, IDC_PREVIEW_PRIORITY, CB_GETCURSEL, 0, 0);
			pdd->prefs.main.iDubPriority = (char)SendDlgItemMessage(hDlg, IDC_DUB_PRIORITY, CB_GETCURSEL, 0, 0);
			pdd->prefs.main.fAttachExtension = IsDlgButtonChecked(hDlg, IDC_TACK_EXTENSION);
			return TRUE;
	}

	return FALSE;
}

static BOOL APIENTRY PreferencesDisplayDlgProc( HWND hDlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hDlg, DWL_USER);

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hDlg, (PrefsDlgData *)lParam);
			SetWindowLong(hDlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////

			CheckDlgButton(hDlg, IDC_ENABLE_16DITHERING, !!(pdd->prefs.fDisplay & Preferences::kDisplayDither16));
			CheckDlgButton(hDlg, IDC_ENABLE_DIRECTX, !(pdd->prefs.fDisplay & Preferences::kDisplayDisableDX));
			CheckDlgButton(hDlg, IDC_FORCE_DXWITHTS, !!(pdd->prefs.fDisplay & Preferences::kDisplayUseDXWithTS));

			return TRUE;

		case WM_DESTROY:
			pdd->prefs.fDisplay = 0;
			
			if (IsDlgButtonChecked(hDlg, IDC_ENABLE_16DITHERING))
				pdd->prefs.fDisplay += Preferences::kDisplayDither16;
			if (!IsDlgButtonChecked(hDlg, IDC_ENABLE_DIRECTX))
				pdd->prefs.fDisplay += Preferences::kDisplayDisableDX;
			if (IsDlgButtonChecked(hDlg, IDC_FORCE_DXWITHTS))
				pdd->prefs.fDisplay += Preferences::kDisplayUseDXWithTS;
			return TRUE;
	}

	return FALSE;
}

static BOOL APIENTRY PreferencesSceneDlgProc( HWND hDlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hDlg, DWL_USER);
	HWND hwndItem;
	long pos;

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hDlg, (PrefsDlgData *)lParam);
			SetWindowLong(hDlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////

			hwndItem = GetDlgItem(hDlg, IDC_INTERFRAME_SLIDER);
			SendMessage(hwndItem, TBM_SETRANGE, FALSE, MAKELONG(0,255));
			SendMessage(hwndItem, TBM_SETPOS, TRUE,
					pdd->prefs.scene.iCutThreshold
						? 256 - ((pdd->prefs.scene.iCutThreshold+8)>>4)
						: 0
					);
			SendMessage(hDlg, WM_HSCROLL, 0, (LPARAM)hwndItem);

			hwndItem = GetDlgItem(hDlg, IDC_INTRAFRAME_SLIDER);
			SendMessage(hwndItem, TBM_SETRANGE, FALSE, MAKELONG(0,256));
			SendMessage(hwndItem, TBM_SETPOS, TRUE, pdd->prefs.scene.iFadeThreshold);
			SendMessage(hDlg, WM_HSCROLL, 0, (LPARAM)hwndItem);

			return TRUE;

		case WM_HSCROLL:
			pos = SendMessage((HWND)lParam, TBM_GETPOS, 0, 0);
			switch(GetWindowLong((HWND)lParam, GWL_ID)) {
			case IDC_INTERFRAME_SLIDER:
				if (!pos)
					SetDlgItemText(hDlg, IDC_INTERFRAME_VALUE, "Off");
				else
					SetDlgItemInt(hDlg, IDC_INTERFRAME_VALUE, pos, FALSE);
				return TRUE;
			case IDC_INTRAFRAME_SLIDER:
				if (!pos)
					SetDlgItemText(hDlg, IDC_INTRAFRAME_VALUE, "Off");
				else
					SetDlgItemInt(hDlg, IDC_INTRAFRAME_VALUE, pos, FALSE);

				return TRUE;
			}
			break;

		case WM_DESTROY:
			{
				int x = SendDlgItemMessage(hDlg, IDC_INTERFRAME_SLIDER, TBM_GETPOS, 0, 0);

				pdd->prefs.scene.iCutThreshold = x?(256-x)<<4:0;
				pdd->prefs.scene.iFadeThreshold = SendDlgItemMessage(hDlg, IDC_INTRAFRAME_SLIDER, TBM_GETPOS, 0, 0);
			}
			return TRUE;
	}

	return FALSE;
}

static BOOL APIENTRY PreferencesCPUDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hDlg, DWL_USER);
	BOOL fTemp;

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hDlg, (PrefsDlgData *)lParam);
			SetWindowLong(hDlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////

			CheckDlgButton(hDlg, IDC_PERFOPT_FPU, !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_FPU));
			CheckDlgButton(hDlg, IDC_PERFOPT_MMX, !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_MMX));
			CheckDlgButton(hDlg, IDC_PERFOPT_SSE, !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_SSE));
			CheckDlgButton(hDlg, IDC_PERFOPT_SSE2, !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_SSE2));
			CheckDlgButton(hDlg, IDC_PERFOPT_SSEPARTIAL, !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_INTEGER_SSE));
			CheckDlgButton(hDlg, IDC_PERFOPT_3DNOW, !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_3DNOW));
			CheckDlgButton(hDlg, IDC_PERFOPT_3DNOW2, !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_3DNOW_EXT));

			if (pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_FORCE) {
				CheckDlgButton(hDlg, IDC_PERFOPT_FORCE, TRUE);
			} else {
				CheckDlgButton(hDlg, IDC_PERFOPT_DEFAULT, TRUE);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_FPU), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_MMX), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_SSE), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_SSE2), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_SSEPARTIAL), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_3DNOW), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_3DNOW2), FALSE);
			}

			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDC_PERFOPT_DEFAULT:
			case IDC_PERFOPT_FORCE:
				fTemp = !!(SendMessage(GetDlgItem(hDlg, IDC_PERFOPT_FORCE), BM_GETSTATE, 0, 0)&3);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_FPU), fTemp);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_MMX), fTemp);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_SSE), fTemp);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_SSE2), fTemp);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_SSEPARTIAL), fTemp);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_3DNOW), fTemp);
				EnableWindow(GetDlgItem(hDlg, IDC_PERFOPT_3DNOW2), fTemp);
			}
			return TRUE;

		case WM_DESTROY:
			pdd->prefs.main.fOptimizations	= (IsDlgButtonChecked(hDlg, IDC_PERFOPT_FORCE) ? PreferencesMain::OPTF_FORCE : 0)
											| (IsDlgButtonChecked(hDlg, IDC_PERFOPT_FPU) ? PreferencesMain::OPTF_FPU : 0)
											| (IsDlgButtonChecked(hDlg, IDC_PERFOPT_MMX) ? PreferencesMain::OPTF_MMX : 0)
											| (IsDlgButtonChecked(hDlg, IDC_PERFOPT_3DNOW) ? PreferencesMain::OPTF_3DNOW : 0)
											| (IsDlgButtonChecked(hDlg, IDC_PERFOPT_3DNOW2) ? PreferencesMain::OPTF_3DNOW_EXT : 0)
											| (IsDlgButtonChecked(hDlg, IDC_PERFOPT_SSEPARTIAL) ? PreferencesMain::OPTF_INTEGER_SSE : 0)
											| (IsDlgButtonChecked(hDlg, IDC_PERFOPT_SSE) ? PreferencesMain::OPTF_SSE : 0)
											| (IsDlgButtonChecked(hDlg, IDC_PERFOPT_SSE2) ? PreferencesMain::OPTF_SSE2 : 0);
			return TRUE;
	}

	return FALSE;
}

static BOOL APIENTRY PreferencesAVIDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hdlg, DWL_USER);

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hdlg, (PrefsDlgData *)lParam);
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////

			CheckDlgButton(hdlg, IDC_RESTRICT_AVI_1GB, !!pdd->prefs.fAVIRestrict1Gb);
			CheckDlgButton(hdlg, IDC_AUTOCORRECT_L3, !!pdd->prefs.fNoCorrectLayer3);
			return TRUE;

		case WM_DESTROY:
			pdd->prefs.fAVIRestrict1Gb = IsDlgButtonChecked(hdlg, IDC_RESTRICT_AVI_1GB);
			pdd->prefs.fNoCorrectLayer3 = IsDlgButtonChecked(hdlg, IDC_AUTOCORRECT_L3);
			return TRUE;
	}

	return FALSE;
}

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, Feb 2003												***
// BEGIN **************************************************************
static void ModTree_SetLabel(ModTreeControl_Control *control, LPCTSTR pszLabel) {
	if(control) {
		if(pszLabel)
			control->SetLabel(pszLabel);
		else
			control->SetLabel(_T(""));
	}
}

static void ModTree_SetLabel(ModTreeControl_Control *control, UINT nLabel) {
	if(control && nLabel) {
		TCHAR szBuffer[4096];
		memset(szBuffer, 0, sizeof(szBuffer));
		if(LoadString(g_hInst, nLabel, szBuffer, sizeof(szBuffer)/sizeof(szBuffer[0])))
			ModTree_SetLabel(control, szBuffer);
	}
}

static void ModTree_SetInfoTip(ModTreeControl_Control *control, LPCTSTR pszInfoTip) {
	if(control) {
		if(pszInfoTip)
			control->SetToolTip(pszInfoTip);
		else
			control->SetToolTip(_T(""));
	}
}

static void ModTree_SetInfoTip(ModTreeControl_Control *control, UINT nInfoTip) {
	if(control && nInfoTip) {
		TCHAR szBuffer[4096];
		memset(szBuffer, 0, sizeof(szBuffer));
		if(LoadString(g_hInst, nInfoTip, szBuffer, sizeof(szBuffer)/sizeof(szBuffer[0])))
			ModTree_SetInfoTip(control, szBuffer);
	}
}

static void ModTree_AddValue(ModTreeControl_ComboBox *control, LPCTSTR pszValue, bool bSelected) {
	if(control) {
		if(pszValue)
			control->AddValue(pszValue, bSelected);
		else
			control->AddValue(_T(""), bSelected);
	}
}

static void ModTree_AddValue(ModTreeControl_ComboBox *control, UINT nValue, bool bSelected) {
	if(control && nValue) {
		TCHAR szBuffer[4096];
		memset(szBuffer, 0, sizeof(szBuffer));
		if(LoadString(g_hInst, nValue, szBuffer, sizeof(szBuffer)/sizeof(szBuffer[0])))
			ModTree_AddValue(control, szBuffer, bSelected);
	}
}

void AddModeToTreeCombo(int iID, LPCTSTR szValue, UINT iState, void *pData) {
	ModTreeControl_ComboBox *cBox = (ModTreeControl_ComboBox *)pData;
	if(!cBox)
		return;
	ModTree_AddValue(cBox, szValue, false);
}

static BOOL APIENTRY PreferencesVDModDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hdlg, DWL_USER);

	static HMENU hMenuNormal;

	static struct {
		ModTreeControl *treeControl;
		ModTreeControl_ComboBox *prefMain_Preview_OutputDepth;
		ModTreeControl_ComboBox *prefMain_Preview_Priority;
		ModTreeControl_ComboBox *prefMain_Dub_Priority;
		ModTreeControl_CheckBox *prefMain_File_AddExtension;
		ModTreeControl_ComboBox *prefMain_VideoMode;
		ModTreeControl_CheckBox *prefDisplay_16bitDithering;
		ModTreeControl_CheckBox *prefDisplay_UseDirectX;
		ModTreeControl_CheckBox *prefDisplay_UseDirectXWithTS;
		ModTreeControl_CheckBox *prefDisplay_DisplayInputVideo;
		ModTreeControl_CheckBox *prefDisplay_DisplayOutputVideo;
		ModTreeControl_CheckBox *prefDisplay_AutoResize;
		ModTreeControl_FileSelect *prefDisplay_LanguageFile;
		ModTreeControl_RadioButton *prefCPU_DefaultOptim;
		ModTreeControl_RadioButton *prefCPU_ForceOptim;
		ModTreeControl_CheckBox *prefCPU_ForceOptim_FPU;
		ModTreeControl_CheckBox *prefCPU_ForceOptim_MMX;
		ModTreeControl_CheckBox *prefCPU_ForceOptim_ISSE;
		ModTreeControl_CheckBox *prefCPU_ForceOptim_SSE;
		ModTreeControl_CheckBox *prefCPU_ForceOptim_SSE2;
		ModTreeControl_CheckBox *prefCPU_ForceOptim_3DNOW;
		ModTreeControl_CheckBox *prefCPU_ForceOptim_3DNOW2;
		ModTreeControl_CheckBox *prefAVI_RestrictLegacyAVI;
		ModTreeControl_CheckBox *prefAVI_NoMP3Correction;
		ModTreeControl_CheckBox *prefAVI_NandubTrick;
		ModTreeControl_CheckBox *prefAVI_FrameMode;
		ModTreeControl_ComboBox *prefAVI_RECListsMode;
		ModTreeControl_EditBox *prefAVI_RECListsLimit;
		ModTreeControl_EditBox *prefAudio_DefaultPreload;
		ModTreeControl_CheckBox *prefAudio_PreloadOnlyAVI;
		ModTreeControl_CheckBox *prefAudio_KeepCorruptedData;
		ModTreeControl_CheckBox *prefAudio_PrissRocks;
		ModTreeControl_EditBox *prefAudio_GroupFrames;
		ModTreeControl_EditBox *prefMatroska_ClusterLimit;
		ModTreeControl_CheckBox *prefMatroska_UseLacing;
		ModTreeControl_RadioButton *prefMatroska_Cue_IndexAll;
		ModTreeControl_RadioButton *prefMatroska_Cue_IndexKeyOnly;
		ModTreeControl_CheckBox *prefMatroska_Cue_IndexVideoOnly;
		ModTreeControl_CheckBox *prefMatroska_Seek_IndexClusters;
		ModTreeControl_CheckBox *prefMatroska_Seek_PreviousClusterSize;
		//ModTreeControl_CheckBox *prefMatroska_FasterReadAccess;	// Deprecated
		ModTreeControl_CheckBox *prefScriptEditor_SingleInstance;
		ModTreeControl_CheckBox *prefScriptEditor_AutoPopup;
	} s_TreeControls;

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hdlg, (PrefsDlgData *)lParam);
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;
			hMenuNormal = g_projectui->getMainMenu();

			//////////////
			{
				memset(&s_TreeControls, 0, sizeof(s_TreeControls));
				RECT wRect;
				GetWindowRect(hdlg, &wRect);
				ModTreeControl* treeControl = ModTreeControl::Create(hdlg, 5, 5, wRect.right-wRect.left-10, wRect.bottom-wRect.top-10, 0);
				s_TreeControls.treeControl = treeControl;
				if(treeControl) {
					TCHAR szBuffer[4096];
					int iBufferLen = sizeof(szBuffer) / sizeof(szBuffer[0]);
					int iSel;
					// ***** Main Preferences *****
					ModTreeControl_Control *prefMain = treeControl->AddGroup(NULL, _T(""), _T(""));
					if(prefMain) {
						ModTree_SetLabel(prefMain, IDS_PREF_MAIN);
						// ***** Preview Preferences *****
						ModTreeControl_Control *prefMain_Preview = treeControl->AddGroup(prefMain, _T(""), _T(""));
						if(prefMain_Preview) {
							ModTree_SetLabel(prefMain_Preview, IDS_PREF_MAIN_PREVIEW);
							// Output dpeth
							s_TreeControls.prefMain_Preview_OutputDepth = treeControl->AddComboBox(prefMain_Preview, _T(""), _T(""));
							ModTree_SetLabel(s_TreeControls.prefMain_Preview_OutputDepth, IDS_PREF_MAIN_PREVIEW_OUTPUTDEPTH);
							ModTree_AddValue(s_TreeControls.prefMain_Preview_OutputDepth, IDS_PREF_MAIN_PREVIEW_OUTPUTDEPTH_FASTEST, false);
							ModTree_AddValue(s_TreeControls.prefMain_Preview_OutputDepth, IDS_PREF_MAIN_PREVIEW_OUTPUTDEPTH_DEFAULT, false);
							ModTree_AddValue(s_TreeControls.prefMain_Preview_OutputDepth, IDS_PREF_MAIN_PREVIEW_OUTPUTDEPTH_DISPLAY, false);
							ModTree_AddValue(s_TreeControls.prefMain_Preview_OutputDepth, IDS_PREF_MAIN_PREVIEW_OUTPUTDEPTH_HICOLOR, false);
							ModTree_AddValue(s_TreeControls.prefMain_Preview_OutputDepth, IDS_PREF_MAIN_PREVIEW_OUTPUTDEPTH_TRUECOLOR, false);
							s_TreeControls.prefMain_Preview_OutputDepth->SelectValue(pdd->prefs.main.iPreviewDepth);
							// Preview priority
							s_TreeControls.prefMain_Preview_Priority = treeControl->AddComboBox(prefMain_Preview, _T(""), _T(""));
							ModTree_SetLabel(s_TreeControls.prefMain_Preview_Priority, IDS_PREF_MAIN_PREVIEW_PRIORITY);
							ModTree_AddValue(s_TreeControls.prefMain_Preview_Priority, _T("Default"), false);
							for(iSel=0; iSel<8; iSel++)
								ModTree_AddValue(s_TreeControls.prefMain_Preview_Priority, g_szDubPriorities[iSel], false);
							s_TreeControls.prefMain_Preview_Priority->SelectValue(pdd->prefs.main.iPreviewPriority);
						}
						// Dub priority
						s_TreeControls.prefMain_Dub_Priority = treeControl->AddComboBox(prefMain, _T(""), _T(""));
						ModTree_SetLabel(s_TreeControls.prefMain_Dub_Priority, IDS_PREF_MAIN_DUB_PRIORITY);
						ModTree_AddValue(s_TreeControls.prefMain_Dub_Priority, _T("Default"), false);
						for(iSel=0; iSel<8; iSel++)
							ModTree_AddValue(s_TreeControls.prefMain_Dub_Priority, g_szDubPriorities[iSel], false);
						s_TreeControls.prefMain_Dub_Priority->SelectValue(pdd->prefs.main.iDubPriority);
						// Add file extension
						s_TreeControls.prefMain_File_AddExtension = treeControl->AddCheckBox(prefMain, _T(""), !!pdd->prefs.main.fAttachExtension, _T(""));
						ModTree_SetLabel(s_TreeControls.prefMain_File_AddExtension, IDS_PREF_MAIN_FILE_ADDEXTENSION);
						// Default video mode
						s_TreeControls.prefMain_VideoMode = treeControl->AddComboBox(prefMain, _T(""), _T(""));
						ModTree_SetLabel(s_TreeControls.prefMain_VideoMode, IDS_PREF_MAIN_VIDEOMODE);
						ModEnumVideoModes(AddModeToTreeCombo, s_TreeControls.prefMain_VideoMode);
						s_TreeControls.prefMain_VideoMode->SelectValue(pdd->m_VDMPrefs.m_DefaultVideoMode);
					}
					// ***** Display Preferences *****
					ModTreeControl_Control *prefDisplay = treeControl->AddGroup(NULL, _T(""), _T(""));
					if(prefDisplay) {
						ModTree_SetLabel(prefDisplay, IDS_PREF_DISPLAY);
						// 16-bit dithering
						s_TreeControls.prefDisplay_16bitDithering = treeControl->AddCheckBox(prefDisplay, _T(""), !!(pdd->prefs.fDisplay & Preferences::kDisplayDither16), _T(""));
						ModTree_SetLabel(s_TreeControls.prefDisplay_16bitDithering, IDS_PREF_DISPLAY_16BITDITHERING);
						// Use DirectX
						s_TreeControls.prefDisplay_UseDirectX = treeControl->AddCheckBox(prefDisplay, _T(""), !(pdd->prefs.fDisplay & Preferences::kDisplayDisableDX), _T(""));
						ModTree_SetLabel(s_TreeControls.prefDisplay_UseDirectX, IDS_PREF_DISPLAY_USEDIRECTX);
						// Use DirectX even with Terminal Services
						s_TreeControls.prefDisplay_UseDirectXWithTS = treeControl->AddCheckBox(prefDisplay, _T(""), !!(pdd->prefs.fDisplay & Preferences::kDisplayUseDXWithTS), _T(""));
						ModTree_SetLabel(s_TreeControls.prefDisplay_UseDirectXWithTS, IDS_PREF_DISPLAY_USEDIRECTX_TERMINALSERVICES);
						// Display input video
						s_TreeControls.prefDisplay_DisplayInputVideo = treeControl->AddCheckBox(prefDisplay, _T(""), !!pdd->m_VDMPrefs.m_bShowInputFrame, _T(""));
						UINT iLength = iBufferLen;
						ModGetMenuItemText(hMenuNormal, ID_OPTIONS_DISPLAYINPUTVIDEO, FALSE, szBuffer, iLength);
						ModTree_SetLabel(s_TreeControls.prefDisplay_DisplayInputVideo, szBuffer);
						// Display output video
						s_TreeControls.prefDisplay_DisplayOutputVideo = treeControl->AddCheckBox(prefDisplay, _T(""), !!pdd->m_VDMPrefs.m_bShowOutputFrame, _T(""));
						iLength = iBufferLen;
						ModGetMenuItemText(hMenuNormal, ID_OPTIONS_DISPLAYOUTPUTVIDEO, FALSE, szBuffer, iLength);
						ModTree_SetLabel(s_TreeControls.prefDisplay_DisplayOutputVideo, szBuffer);
						// Auto-resize & center window
						s_TreeControls.prefDisplay_AutoResize = treeControl->AddCheckBox(prefDisplay, _T(""), !!pdd->m_VDMPrefs.m_bAutoResize, _T(""));
						ModTree_SetLabel(s_TreeControls.prefDisplay_AutoResize, IDS_PREF_DISPLAY_AUTORESIZE);
						// Language (Dll) file
						s_TreeControls.prefDisplay_LanguageFile = treeControl->AddFileSelect(prefDisplay, _T(""), pdd->LanguageDLL, _T(""));
						ModTree_SetLabel(s_TreeControls.prefDisplay_LanguageFile, IDS_PREF_DISPLAY_LANGUAGEFILE);
						s_TreeControls.prefDisplay_LanguageFile->SetWidth(200);
						s_TreeControls.prefDisplay_LanguageFile->SetFilters(
							_T("Language DLLs (*.dll)\0")	_T("*.dll\0")
							_T("All files (*.*)\0")			_T("*.*\0")
						);
					}
					// ***** CPU Preferences *****
					ModTreeControl_Control *prefCPU = treeControl->AddGroup(NULL, _T(""), _T(""));
					if(prefCPU) {
						ModTree_SetLabel(prefCPU, IDS_PREF_CPU);
						// Default optimizations
						s_TreeControls.prefCPU_DefaultOptim = treeControl->AddRadioButton(prefCPU, _T(""), !(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_FORCE), _T(""));
						ModTree_SetLabel(s_TreeControls.prefCPU_DefaultOptim, IDS_PREF_CPU_DEFAULTOPTIM);
						ModTree_SetInfoTip(s_TreeControls.prefCPU_DefaultOptim, IDS_PREF_CPU_DEFAULTOPTIM_TIP);
						// Force optimizations
						s_TreeControls.prefCPU_ForceOptim = treeControl->AddRadioButton(prefCPU, _T(""), (pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_FORCE), _T(""));
						if(s_TreeControls.prefCPU_ForceOptim) {
							ModTree_SetLabel(s_TreeControls.prefCPU_ForceOptim, IDS_PREF_CPU_FORCEOPTIM);
							s_TreeControls.prefCPU_ForceOptim_FPU = treeControl->AddCheckBox(s_TreeControls.prefCPU_ForceOptim, _T("FPU"), !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_FPU), _T(""));
							s_TreeControls.prefCPU_ForceOptim_MMX = treeControl->AddCheckBox(s_TreeControls.prefCPU_ForceOptim, _T("MMX"), !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_MMX), _T(""));
							s_TreeControls.prefCPU_ForceOptim_ISSE = treeControl->AddCheckBox(s_TreeControls.prefCPU_ForceOptim, _T("Integer SSE"), !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_INTEGER_SSE), _T(""));
							s_TreeControls.prefCPU_ForceOptim_SSE = treeControl->AddCheckBox(s_TreeControls.prefCPU_ForceOptim, _T("SSE"), !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_SSE), _T(""));
							s_TreeControls.prefCPU_ForceOptim_SSE2 = treeControl->AddCheckBox(s_TreeControls.prefCPU_ForceOptim, _T("SSE2"), !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_SSE2), _T(""));
							s_TreeControls.prefCPU_ForceOptim_3DNOW = treeControl->AddCheckBox(s_TreeControls.prefCPU_ForceOptim, _T("3D Now!"), !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_3DNOW), _T(""));
							s_TreeControls.prefCPU_ForceOptim_3DNOW2 = treeControl->AddCheckBox(s_TreeControls.prefCPU_ForceOptim, _T("3D Now! 2"), !!(pdd->prefs.main.fOptimizations & PreferencesMain::OPTF_3DNOW_EXT), _T(""));
						}
					}
					// ***** AVI Preferences *****
					ModTreeControl_Control *prefAVI = treeControl->AddGroup(NULL, _T(""), _T(""));
					if(prefAVI) {
						ModTree_SetLabel(prefAVI, _T("AVI"));
						// Restrict legacy AVI file size
						s_TreeControls.prefAVI_RestrictLegacyAVI = treeControl->AddCheckBox(prefAVI, _T(""), !!pdd->prefs.fAVIRestrict1Gb, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAVI_RestrictLegacyAVI, IDS_PREF_AVI_RESTRICTLEGACYAVI);
						ModTree_SetInfoTip(s_TreeControls.prefAVI_RestrictLegacyAVI, IDS_PREF_AVI_RESTRICTLEGACYAVI_TIP);
						// No MP3 correction
						s_TreeControls.prefAVI_NoMP3Correction = treeControl->AddCheckBox(prefAVI, _T(""), !!pdd->prefs.fNoCorrectLayer3, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAVI_NoMP3Correction, IDS_PREF_AVI_NOMP3CORRECTION);
						ModTree_SetInfoTip(s_TreeControls.prefAVI_NoMP3Correction, IDS_PREF_AVI_NOMP3CORRECTION_TIP);
						// Use Nandub trick
						s_TreeControls.prefAVI_NandubTrick = treeControl->AddCheckBox(prefAVI, _T(""), !!pdd->m_VDMPrefs.m_bNandubCompatibility, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAVI_NandubTrick, IDS_PREF_AVI_NANDUBTRICK);
						ModTree_SetInfoTip(s_TreeControls.prefAVI_NandubTrick, IDS_PREF_AVI_NANDUBTRICK_TIP);
						// Use Frame mode
						s_TreeControls.prefAVI_FrameMode = treeControl->AddCheckBox(prefAVI, _T(""), !!pdd->m_VDMPrefs.m_bAudioFrameMode, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAVI_FrameMode, IDS_PREF_AVI_FRAMEMODE);
						ModTree_SetInfoTip(s_TreeControls.prefAVI_FrameMode, IDS_PREF_AVI_FRAMEMODE_TIP);
						// Use AVI 'rec ' lists
						s_TreeControls.prefAVI_RECListsMode = treeControl->AddComboBox(prefAVI, _T(""), _T(""));
						ModTree_SetLabel(s_TreeControls.prefAVI_RECListsMode, IDS_PREF_AVI_RECLISTMODE);
						ModTree_SetInfoTip(s_TreeControls.prefAVI_RECListsMode, IDS_PREF_AVI_RECLISTMODE_TIP);
						ModTree_AddValue(s_TreeControls.prefAVI_RECListsMode, IDS_NO, false);
						ModTree_AddValue(s_TreeControls.prefAVI_RECListsMode, IDS_PREF_AVI_RECLISTMODE_LIMITSIZE, false);
						ModTree_AddValue(s_TreeControls.prefAVI_RECListsMode, IDS_PREF_AVI_RECLISTMODE_LIMITFRAMES, false);
						s_TreeControls.prefAVI_RECListsMode->SelectValue(pdd->m_VDMPrefs.m_AVIRecListsMode);
						// AVI 'rec ' lists limit
						_sntprintf(szBuffer, iBufferLen, _T("%u"), pdd->m_VDMPrefs.m_AVIRevListsLimit);
						s_TreeControls.prefAVI_RECListsLimit = treeControl->AddEditBox(prefAVI, _T(""), szBuffer, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAVI_RECListsLimit, IDS_PREF_AVI_RECLISTLIMIT);
					}
					// ***** Audio Preferences *****
					ModTreeControl_Control *prefAudio = treeControl->AddGroup(NULL, _T(""), _T(""));
					if(prefAudio) {
						ModTree_SetLabel(prefAudio, IDS_PREF_AUDIO);
						// Default preload
						_sntprintf(szBuffer, iBufferLen, _T("%u"), pdd->m_VDMPrefs.m_DefaultPreload);
						s_TreeControls.prefAudio_DefaultPreload = treeControl->AddEditBox(prefAudio, _T(""), szBuffer, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAudio_DefaultPreload, IDS_PREF_AUDIO_DEFAULTPRELOAD);
						ModTree_SetInfoTip(s_TreeControls.prefAudio_DefaultPreload, IDS_PREF_AUDIO_DEFAULTPRELOAD_TIP);
						// Preload only for AVI
						s_TreeControls.prefAudio_PreloadOnlyAVI = treeControl->AddCheckBox(prefAudio, _T(""), !!pdd->m_VDMPrefs.m_bDisablePreload, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAudio_PreloadOnlyAVI, IDS_PREF_AUDIO_PRELOADONLYAVI);
						ModTree_SetInfoTip(s_TreeControls.prefAudio_PreloadOnlyAVI, IDS_PREF_AUDIO_PRELOADONLYAVI_TIP);
						// Keep corrupted data
						s_TreeControls.prefAudio_KeepCorruptedData = treeControl->AddCheckBox(prefAudio, _T(""), !!pdd->m_VDMPrefs.m_bKeepCorruptedData, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAudio_KeepCorruptedData, IDS_PREF_AUDIO_KEEPCORRUPTEDDATA);
						ModTree_SetInfoTip(s_TreeControls.prefAudio_KeepCorruptedData, IDS_PREF_AUDIO_KEEPCORRUPTEDDATA_TIP);
						// Priss rocks (use VirtualDub internal MP3 decoder)
						s_TreeControls.prefAudio_PrissRocks = treeControl->AddCheckBox(prefAudio, _T(""), !!pdd->m_VDMPrefs.m_bPrissRocks, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAudio_PrissRocks, IDS_PREF_AUDIO_PRISSROCKS);
						ModTree_SetInfoTip(s_TreeControls.prefAudio_PrissRocks, IDS_PREF_AUDIO_PRISSROCKS_TIP);
						// Group frames
						_sntprintf(szBuffer, iBufferLen, _T("%u"), pdd->m_VDMPrefs.m_GroupFrames);
						s_TreeControls.prefAudio_GroupFrames = treeControl->AddEditBox(prefAudio, _T(""), szBuffer, _T(""));
						ModTree_SetLabel(s_TreeControls.prefAudio_GroupFrames, IDS_PREF_AUDIO_GROUPFRAMES);
						ModTree_SetInfoTip(s_TreeControls.prefAudio_GroupFrames, IDS_PREF_AUDIO_GROUPFRAMES_TIP);
					}
					// ***** Matroska Preferences *****
					ModTreeControl_Control *prefMatroska = treeControl->AddGroup(NULL, _T(""), _T(""));
					if(prefMatroska) {
						ModTree_SetLabel(prefMatroska, _T("Matroska"));
						// Cluster limit
						_sntprintf(szBuffer, iBufferLen, _T("%u"), pdd->m_MKVPrefs.m_ClusterTimeLimit);
						s_TreeControls.prefMatroska_ClusterLimit = treeControl->AddEditBox(prefMatroska, _T(""), szBuffer, _T(""));
						ModTree_SetLabel(s_TreeControls.prefMatroska_ClusterLimit, IDS_PREF_MATROSKA_LIMITCLUSTER);
						// Use lacing
						s_TreeControls.prefMatroska_UseLacing = treeControl->AddCheckBox(prefMatroska, _T(""), !!pdd->m_MKVPrefs.m_bEnableLacing, _T(""));
						ModTree_SetLabel(s_TreeControls.prefMatroska_UseLacing, IDS_PREF_MATROSKA_USELACING);
						// ***** Cue system *****
						ModTreeControl_Control *prefMatroska_Cue = treeControl->AddGroup(prefMatroska, _T(""), _T(""));
						if(prefMatroska_Cue) {
							ModTree_SetLabel(prefMatroska_Cue, IDS_PREF_MATROSKA_CUE);
							// Index all frames
							s_TreeControls.prefMatroska_Cue_IndexAll = treeControl->AddRadioButton(prefMatroska_Cue, _T(""), !pdd->m_MKVPrefs.m_CueSystem, _T(""));
							ModTree_SetLabel(s_TreeControls.prefMatroska_Cue_IndexAll, IDS_PREF_MATROSKA_CUE_INDEXALLFRAMES);
							// Index only keyframes
							s_TreeControls.prefMatroska_Cue_IndexKeyOnly = treeControl->AddRadioButton(prefMatroska_Cue, _T(""), !!pdd->m_MKVPrefs.m_CueSystem, _T(""));
							ModTree_SetLabel(s_TreeControls.prefMatroska_Cue_IndexKeyOnly, IDS_PREF_MATROSKA_CUE_INDEXKEYFRAMES);
							// Index only video streams
							s_TreeControls.prefMatroska_Cue_IndexVideoOnly = treeControl->AddCheckBox(prefMatroska_Cue, _T(""), !!pdd->m_MKVPrefs.m_CueOnlyVideo, _T(""));
							ModTree_SetLabel(s_TreeControls.prefMatroska_Cue_IndexVideoOnly, IDS_PREF_MATROSKA_CUE_INDEXONLYVIDEO);
						}
						// ***** Seeking system *****
						ModTreeControl_Control *prefMatroska_Seek = treeControl->AddGroup(prefMatroska, _T(""), _T(""));
						if(prefMatroska_Seek) {
							ModTree_SetLabel(prefMatroska_Seek, IDS_PREF_MATROSKA_SEEK);
							// Index cluster position
							s_TreeControls.prefMatroska_Seek_IndexClusters = treeControl->AddCheckBox(prefMatroska_Seek, _T(""), !!pdd->m_MKVPrefs.m_IndexClusters, _T(""));
							ModTree_SetLabel(s_TreeControls.prefMatroska_Seek_IndexClusters, IDS_PREF_MATROSKA_SEEK_INDEXCLSUTERS);
							// Set previous cluster size
							s_TreeControls.prefMatroska_Seek_PreviousClusterSize = treeControl->AddCheckBox(prefMatroska_Seek, _T(""), !!pdd->m_MKVPrefs.m_SetPreviousClusterSize, _T(""));
							ModTree_SetLabel(s_TreeControls.prefMatroska_Seek_PreviousClusterSize, IDS_PREF_MATROSKA_SEEK_PREVIOUSCLUSTERSIZE);
						}
						// Faster read access, Deprecated
						/*s_TreeControls.prefMatroska_FasterReadAccess = treeControl->AddCheckBox(prefMatroska, _T(""), !!pdd->m_MKVPrefs.m_bFasterReadAccess, _T(""));
						ModTree_SetLabel(s_TreeControls.prefMatroska_FasterReadAccess, IDS_PREF_MATROSKA_FASTERREADACCESS);
						ModTree_SetInfoTip(s_TreeControls.prefMatroska_FasterReadAccess, IDS_PREF_MATROSKA_FASTERREADACCESS_TIP);*/
					}
					// ***** Script Editor Preferences *****
					ModTreeControl_Control *prefScriptEditor = treeControl->AddGroup(NULL, _T(""), _T(""));
					if(prefAudio) {
						ModTree_SetLabel(prefScriptEditor, IDS_PREF_SCRIPTEDITOR);
						// Single Instance Mode
						s_TreeControls.prefScriptEditor_SingleInstance = treeControl->AddCheckBox(prefScriptEditor, _T(""), !!pdd->m_VDMPrefs.m_bScriptEditorSingleInstance, _T(""));
						ModTree_SetLabel(s_TreeControls.prefScriptEditor_SingleInstance, IDS_PREF_SCRIPTEDITOR_SINGLEINSTANCE);
						ModTree_SetInfoTip(s_TreeControls.prefScriptEditor_SingleInstance, IDS_PREF_SCRIPTEDITOR_SINGLEINSTANCE_TIP);
						// Preload only for AVI
						s_TreeControls.prefScriptEditor_AutoPopup = treeControl->AddCheckBox(prefScriptEditor, _T(""), !!pdd->m_VDMPrefs.m_bScriptEditorAutoPopup, _T(""));
						ModTree_SetLabel(s_TreeControls.prefScriptEditor_AutoPopup, IDS_PREF_SCRIPTEDITOR_AUTOPOPUP);
						ModTree_SetInfoTip(s_TreeControls.prefScriptEditor_AutoPopup, IDS_PREF_SCRIPTEDITOR_AUTOPOPUP_TIP);
					}
					treeControl->Expand(true);
					if(!s_TreeControls.prefCPU_ForceOptim->Checked())
						s_TreeControls.prefCPU_ForceOptim->Collapse(false);
				}
			}
			return TRUE;

		case WM_DESTROY:
			{
				LPCTSTR szValue;
				long iValue;
				if(s_TreeControls.treeControl) {
					s_TreeControls.treeControl->Flush();
					// ***** Main Preferences *****
					pdd->prefs.main.iPreviewDepth = s_TreeControls.prefMain_Preview_OutputDepth->GetSelected();
					pdd->prefs.main.iPreviewPriority = s_TreeControls.prefMain_Preview_Priority->GetSelected();
					pdd->prefs.main.iDubPriority = s_TreeControls.prefMain_Dub_Priority->GetSelected();
					pdd->prefs.main.fAttachExtension = s_TreeControls.prefMain_File_AddExtension->Checked();
					pdd->m_VDMPrefs.m_DefaultVideoMode = s_TreeControls.prefMain_VideoMode->GetSelected();
					// ***** Display Preferences *****
					pdd->prefs.fDisplay = 0;
					if(s_TreeControls.prefDisplay_16bitDithering->Checked())
						pdd->prefs.fDisplay += Preferences::kDisplayDither16;
					if(!s_TreeControls.prefDisplay_UseDirectX->Checked())
						pdd->prefs.fDisplay += Preferences::kDisplayDisableDX;
					if(s_TreeControls.prefDisplay_UseDirectXWithTS->Checked())
						pdd->prefs.fDisplay += Preferences::kDisplayUseDXWithTS;
					pdd->m_VDMPrefs.m_bShowInputFrame = s_TreeControls.prefDisplay_DisplayInputVideo->Checked();
					pdd->m_VDMPrefs.m_bShowOutputFrame = s_TreeControls.prefDisplay_DisplayOutputVideo->Checked();
					pdd->m_VDMPrefs.m_bAutoResize = s_TreeControls.prefDisplay_AutoResize->Checked();
					memset(pdd->LanguageDLL, 0, sizeof(pdd->LanguageDLL));
					szValue = s_TreeControls.prefDisplay_LanguageFile->GetValue();
					if(szValue)
						lstrcpyn(pdd->LanguageDLL, szValue, sizeof(pdd->LanguageDLL)/sizeof(pdd->LanguageDLL[0]));
					// ***** CPU Preferences *****
					pdd->prefs.main.fOptimizations =
						(s_TreeControls.prefCPU_ForceOptim->Checked() ? PreferencesMain::OPTF_FORCE : 0)
						| (s_TreeControls.prefCPU_ForceOptim_FPU->Checked() ? PreferencesMain::OPTF_FPU : 0)
						| (s_TreeControls.prefCPU_ForceOptim_MMX->Checked() ? PreferencesMain::OPTF_MMX : 0)
						| (s_TreeControls.prefCPU_ForceOptim_3DNOW->Checked() ? PreferencesMain::OPTF_3DNOW : 0)
						| (s_TreeControls.prefCPU_ForceOptim_3DNOW2->Checked() ? PreferencesMain::OPTF_3DNOW_EXT : 0)
						| (s_TreeControls.prefCPU_ForceOptim_ISSE->Checked() ? PreferencesMain::OPTF_INTEGER_SSE : 0)
						| (s_TreeControls.prefCPU_ForceOptim_SSE->Checked() ? PreferencesMain::OPTF_SSE : 0)
						| (s_TreeControls.prefCPU_ForceOptim_SSE2->Checked() ? PreferencesMain::OPTF_SSE2 : 0);
					// ***** AVI Preferences *****
					pdd->prefs.fAVIRestrict1Gb = s_TreeControls.prefAVI_RestrictLegacyAVI->Checked();
					pdd->prefs.fNoCorrectLayer3 = s_TreeControls.prefAVI_NoMP3Correction->Checked();
					pdd->m_VDMPrefs.m_bNandubCompatibility = s_TreeControls.prefAVI_NandubTrick->Checked();
					pdd->m_VDMPrefs.m_bAudioFrameMode = s_TreeControls.prefAVI_FrameMode->Checked();
					pdd->m_VDMPrefs.m_AVIRecListsMode = s_TreeControls.prefAVI_RECListsMode->GetSelected();
					szValue = s_TreeControls.prefAVI_RECListsLimit->GetValue();
					if(szValue) {
						iValue = _ttol(szValue);
						if( (iValue>0) && (iValue<0x10000))
							pdd->m_VDMPrefs.m_AVIRevListsLimit = iValue;
					}
					// ***** Audio Preferences *****
					szValue = s_TreeControls.prefAudio_DefaultPreload->GetValue();
					if(szValue) {
						iValue = _ttol(szValue);
						if(iValue>=0)
							pdd->m_VDMPrefs.m_DefaultPreload = iValue;
					}
					pdd->m_VDMPrefs.m_bDisablePreload = s_TreeControls.prefAudio_PreloadOnlyAVI->Checked();
					pdd->m_VDMPrefs.m_bKeepCorruptedData = s_TreeControls.prefAudio_KeepCorruptedData->Checked();
					pdd->m_VDMPrefs.m_bPrissRocks = s_TreeControls.prefAudio_PrissRocks->Checked();
					szValue = s_TreeControls.prefAudio_GroupFrames->GetValue();
					if(szValue) {
						iValue = _ttol(szValue);
						if( (iValue>=0) && (iValue<0x100) )
							pdd->m_VDMPrefs.m_GroupFrames = iValue;
					}
					// ***** Matroska Preferences *****
					szValue = s_TreeControls.prefMatroska_ClusterLimit->GetValue();
					if(szValue) {
						iValue = _ttol(szValue);
						if( (iValue>=0) && (iValue<0x7FFF) )
							pdd->m_MKVPrefs.m_ClusterTimeLimit = iValue;
					}
					pdd->m_MKVPrefs.m_bEnableLacing = s_TreeControls.prefMatroska_UseLacing->Checked();
					pdd->m_MKVPrefs.m_CueSystem = s_TreeControls.prefMatroska_Cue_IndexAll->Checked() ? 0 : 1;
					pdd->m_MKVPrefs.m_CueOnlyVideo = s_TreeControls.prefMatroska_Cue_IndexVideoOnly->Checked();
					pdd->m_MKVPrefs.m_IndexClusters = s_TreeControls.prefMatroska_Seek_IndexClusters->Checked();
					pdd->m_MKVPrefs.m_SetPreviousClusterSize = s_TreeControls.prefMatroska_Seek_PreviousClusterSize->Checked();
					//pdd->m_MKVPrefs.m_bFasterReadAccess = s_TreeControls.prefMatroska_FasterReadAccess->Checked();
					// ***** Script Editor Preferences *****
					pdd->m_VDMPrefs.m_bScriptEditorSingleInstance = s_TreeControls.prefScriptEditor_SingleInstance->Checked();
					pdd->m_VDMPrefs.m_bScriptEditorAutoPopup = s_TreeControls.prefScriptEditor_AutoPopup->Checked();
				}
			}
			return TRUE;
	}

	return FALSE;
}
// END ****************************************************************

// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
void EnableDisableKeyEntries(HWND hdlg) {
	bool bPVirt = !(SendDlgItemMessage(hdlg, IDC_P_MODE, CB_GETCURSEL, 0, 0)==0);
	bool bPEmpty;
	if (bPVirt)
		bPEmpty = SendDlgItemMessage(hdlg, IDC_P_KEY, CB_GETCURSEL, 0, 0)==0;
	else
		bPEmpty = SendDlgItemMessage(hdlg, IDC_P_ASCII, EM_LINELENGTH, 0, 0)==0;
	bool bSVirt = !(SendDlgItemMessage(hdlg, IDC_S_MODE, CB_GETCURSEL, 0, 0)==0);
/*	if (bSVirt)
		bool bSEmpty = SendDlgItemMessage(hdlg, IDC_S_KEY, CB_GETCURSEL, 0, 0)==0;
	else
		bool bSEmpty = SendDlgItemMessage(hdlg, IDC_S_ASCII, EM_LINELENGTH, 0, 0)==0;
*/
	ShowWindow(GetDlgItem(hdlg, IDC_P_KEY), bPVirt);
	ShowWindow(GetDlgItem(hdlg, IDC_P_ASCII), !bPVirt);
	ShowWindow(GetDlgItem(hdlg, IDC_S_KEY), bSVirt);
	ShowWindow(GetDlgItem(hdlg, IDC_S_ASCII), !bSVirt);

	EnableWindow(GetDlgItem(hdlg, IDC_P_CONTROL), bPVirt);
	EnableWindow(GetDlgItem(hdlg, IDC_P_SHIFT), bPVirt);

	EnableWindow(GetDlgItem(hdlg, IDC_S_ALT), !bPEmpty);
	EnableWindow(GetDlgItem(hdlg, IDC_S_CONTROL), bSVirt&&(!bPEmpty));
	EnableWindow(GetDlgItem(hdlg, IDC_S_SHIFT), bSVirt&&(!bPEmpty));
	EnableWindow(GetDlgItem(hdlg, IDC_S_KEY), !bPEmpty);
	EnableWindow(GetDlgItem(hdlg, IDC_S_MODE), !bPEmpty);
	EnableWindow(GetDlgItem(hdlg, IDC_S_ASCII), !bPEmpty);
}

static BOOL APIENTRY KeysDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	ACCELKEYSTRANSFER *pdd = (ACCELKEYSTRANSFER *)GetWindowLong(hdlg, DWL_USER);
//	bool fTemp;
	char b[2];
	bool fVkP;
	bool fVkS;

	switch(message) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (ACCELKEYSTRANSFER *)lParam;

			//////////////
			SetWindowText(hdlg, pdd->description);
			int i, p, s;
			i = 0;
			p = 0;
			s = 0;

			fVkP = pdd->command.altkey[0].fVirt&FVIRTKEY;
			fVkS = pdd->command.altkey[1].fVirt&FVIRTKEY;

			HWND hwndItemP;
			HWND hwndItemS;
			hwndItemP = GetDlgItem(hdlg, IDC_P_KEY);
			hwndItemS = GetDlgItem(hdlg, IDC_S_KEY);
			char *temp;
			while (g_accelKEYKeycode[i]!=0) {
				temp = &g_accelKEYDescription[i][0];
				SendMessage(hwndItemP, CB_ADDSTRING, 0, (LPARAM) temp);
				SendMessage(hwndItemS, CB_ADDSTRING, 0, (LPARAM) temp);
				if ((pdd->command.altkey[0].key==g_accelKEYKeycode[i])&&fVkP) p = i;
				if ((pdd->command.altkey[1].key==g_accelKEYKeycode[i])&&fVkS) s = i;
				i++;
			}
			SendMessage(hwndItemP, CB_SETCURSEL, p, 0);
			SendMessage(hwndItemS, CB_SETCURSEL, s, 0);

			SendDlgItemMessage(hdlg, IDC_P_MODE, CB_ADDSTRING, 0, (LPARAM) "ASCII");
			SendDlgItemMessage(hdlg, IDC_P_MODE, CB_ADDSTRING, 0, (LPARAM) "VIRTKEY");
			SendDlgItemMessage(hdlg, IDC_P_MODE, CB_SETCURSEL, (fVkP)?1:0, 0);
			b[1]=0;
			if (!fVkP) {
				b[0]=pdd->command.altkey[0].key;
				SendDlgItemMessage(hdlg, IDC_P_ASCII, WM_SETTEXT, 0, (LPARAM) &b);
			}
			SendDlgItemMessage(hdlg, IDC_P_ASCII, EM_LIMITTEXT, 1, 0);

			SendDlgItemMessage(hdlg, IDC_S_MODE, CB_ADDSTRING, 0, (LPARAM) "ASCII");
			SendDlgItemMessage(hdlg, IDC_S_MODE, CB_ADDSTRING, 0, (LPARAM) "VIRTKEY");
			SendDlgItemMessage(hdlg, IDC_S_MODE, CB_SETCURSEL, (fVkS)?1:0, 0);
			b[1]=0;
			if (!fVkS) {
				b[0]=pdd->command.altkey[1].key;
				SendDlgItemMessage(hdlg, IDC_S_ASCII, WM_SETTEXT, 0, (LPARAM) &b);
			}
			SendDlgItemMessage(hdlg, IDC_S_ASCII, EM_LIMITTEXT, 1, 0);

			CheckDlgButton(hdlg, IDC_P_ALT, (pdd->command.altkey[0].fVirt&FALT)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hdlg, IDC_P_CONTROL, (pdd->command.altkey[0].fVirt&FCONTROL)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hdlg, IDC_P_SHIFT, (pdd->command.altkey[0].fVirt&FSHIFT)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hdlg, IDC_S_ALT, (pdd->command.altkey[1].fVirt&FALT)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hdlg, IDC_S_CONTROL, (pdd->command.altkey[1].fVirt&FCONTROL)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hdlg, IDC_S_SHIFT, (pdd->command.altkey[1].fVirt&FSHIFT)?BST_CHECKED:BST_UNCHECKED);

			EnableDisableKeyEntries(hdlg);
			return TRUE;

	    case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDC_P_KEY:
			case IDC_P_MODE:
			case IDC_S_MODE:
			case IDC_P_ASCII:
				EnableDisableKeyEntries(hdlg);
				return TRUE;

			case IDOK:
				fVkP = !(SendDlgItemMessage(hdlg, IDC_P_MODE, CB_GETCURSEL, 0, 0)==0);
				fVkS = !(SendDlgItemMessage(hdlg, IDC_S_MODE, CB_GETCURSEL, 0, 0)==0);
				b[0]=0;
				WORD akey;
				if (fVkP)
					akey = g_accelKEYKeycode[SendDlgItemMessage(hdlg, IDC_P_KEY, CB_GETCURSEL, 0, 0)];
				else {
					SendDlgItemMessage(hdlg, IDC_P_ASCII, WM_GETTEXT, 2, (LPARAM) &b);
					akey = b[0];
					if (akey==0) akey = (WORD) -1;
				}
				if (akey == (WORD) -1) {
					pdd->command.altkey[0].key = 0;
					pdd->command.altkey[1].key = 0;
					pdd->command.altkey[0].fVirt = 0;
					pdd->command.altkey[1].fVirt = 0;
				} else {
					pdd->command.altkey[0].key = akey;
					if (fVkP)
						pdd->command.altkey[0].fVirt = FVIRTKEY|(IsDlgButtonChecked(hdlg, IDC_P_ALT)?FALT:0)|(IsDlgButtonChecked(hdlg, IDC_P_CONTROL)?FCONTROL:0)|(IsDlgButtonChecked(hdlg, IDC_P_SHIFT)?FSHIFT:0);
					else
						pdd->command.altkey[0].fVirt = (IsDlgButtonChecked(hdlg, IDC_P_ALT)?FALT:0);
					b[0]=0;
					if (fVkS)
						akey = g_accelKEYKeycode[SendDlgItemMessage(hdlg, IDC_S_KEY, CB_GETCURSEL, 0, 0)];
					else {
						SendDlgItemMessage(hdlg, IDC_S_ASCII, WM_GETTEXT, 2, (LPARAM) &b);
						akey = b[0];
						if (akey==0) akey = (WORD) -1;
					}
					if (akey == (WORD) -1) {
						pdd->command.altkey[1].key = 0;
						pdd->command.altkey[1].fVirt = 0;
					} else {
						pdd->command.altkey[1].key = akey;
						if (fVkS)
							pdd->command.altkey[1].fVirt = FVIRTKEY|(IsDlgButtonChecked(hdlg, IDC_S_ALT)?FALT:0)|(IsDlgButtonChecked(hdlg, IDC_S_CONTROL)?FCONTROL:0)|(IsDlgButtonChecked(hdlg, IDC_S_SHIFT)?FSHIFT:0);
						else
							pdd->command.altkey[1].fVirt = (IsDlgButtonChecked(hdlg, IDC_S_ALT)?FALT:0);
					}
				}
/*				pdd->command.altkey[0].key = g_accelKEYKeycode[SendDlgItemMessage(hdlg, IDC_P_KEY, CB_GETCURSEL, 0, 0)];
				if (pdd->command.altkey[0].key == (WORD) -1) {
					pdd->command.altkey[0].key = 0;
					pdd->command.altkey[1].key = 0;
					pdd->command.altkey[0].fVirt = 0;
					pdd->command.altkey[1].fVirt = 0;
				} else {
					pdd->command.altkey[0].fVirt = FVIRTKEY|(IsDlgButtonChecked(hdlg, IDC_P_ALT)?FALT:0)|(IsDlgButtonChecked(hdlg, IDC_P_CONTROL)?FCONTROL:0)|(IsDlgButtonChecked(hdlg, IDC_P_SHIFT)?FSHIFT:0);
					pdd->command.altkey[1].key = g_accelKEYKeycode[SendDlgItemMessage(hdlg, IDC_S_KEY, CB_GETCURSEL, 0, 0)];
					if (pdd->command.altkey[1].key == (WORD) -1) {
						pdd->command.altkey[1].key = 0;
						pdd->command.altkey[1].fVirt = 0;
					} else {
						pdd->command.altkey[1].fVirt = FVIRTKEY|(IsDlgButtonChecked(hdlg, IDC_S_ALT)?FALT:0)|(IsDlgButtonChecked(hdlg, IDC_S_CONTROL)?FCONTROL:0)|(IsDlgButtonChecked(hdlg, IDC_S_SHIFT)?FSHIFT:0);
					}
				}
*/
				EndDialog(hdlg, TRUE);
				return TRUE;
			case IDCANCEL:

				EndDialog(hdlg, FALSE);
				return TRUE;
			}
            break;
		case WM_DESTROY:
//			pdd->AVSprefs.bAlternateKeys = (IsDlgButtonChecked(hdlg, IDC_REFRESH_KEY)==BST_CHECKED);
			return TRUE;
	}

	return FALSE;
}

/*
static BOOL APIENTRY PreferencesAVSDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hdlg, DWL_USER);

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hdlg, (PrefsDlgData *)lParam);
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////

			CheckDlgButton(hdlg, IDC_REFRESH_KEY, pdd->AVSprefs.bAlternateKeys?BST_CHECKED:BST_UNCHECKED);
			return TRUE;

		case WM_DESTROY:
			pdd->AVSprefs.bAlternateKeys = (IsDlgButtonChecked(hdlg, IDC_REFRESH_KEY)==BST_CHECKED);
			return TRUE;
	}

	return FALSE;
}*/

static BOOL APIENTRY PreferencesMainKeyDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hdlg, DWL_USER);

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hdlg, (PrefsDlgData *)lParam);
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETEXTENDEDLISTVIEWSTYLE,
				LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);


			LVCOLUMN c;
			c.mask = LVCF_TEXT|LVCF_WIDTH;
			c.pszText = "Description";
			c.cx = 154;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 0, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Primary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 1, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Secondary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 2, (LPARAM) &c);

			LVITEM l;
			char buffer[255];
			int i;

			for(i=0; i<VDM_ACCEL_MAIN_COUNT; i++) {
				if (g_accelMainCommand[i]>-1) {
					l.mask = LVIF_PARAM|LVIF_TEXT;
					l.lParam = i;
					l.iItem = i;
					l.iSubItem = 0;
					l.pszText = &g_accelMainDescription[i][0];
					int index = SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTITEM, 0, (LPARAM) &l);
					l.mask = LVIF_TEXT;
					l.iItem = index;
					if (pdd->KeytableMain.command[i].altkey[0].key!=0) {
						l.iSubItem = 1;
						GetKeyString(pdd->KeytableMain.command[i].altkey[0].fVirt, pdd->KeytableMain.command[i].altkey[0].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
					if (pdd->KeytableMain.command[i].altkey[1].key!=0) {
						l.iSubItem = 2;
						GetKeyString(pdd->KeytableMain.command[i].altkey[1].fVirt, pdd->KeytableMain.command[i].altkey[1].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
				}
			}

			//CheckDlgButton(hdlg, IDC_REFRESH_KEY, pdd->AVSprefs.bAlternateKeys?BST_CHECKED:BST_UNCHECKED);
			return TRUE;

		case WM_NOTIFY:
			NMHDR *hdr;
			hdr = (LPNMHDR) lParam;
			if (wParam == IDC_LIST_AVS_KEYS) {
				if (hdr->code == NM_DBLCLK) {
					NMITEMACTIVATE *lpnmitem = (LPNMITEMACTIVATE) lParam;
					ACCELKEYSTRANSFER trans;
					LVITEM l;
					l.iItem = lpnmitem->iItem;
					l.iSubItem = 0;
					l.mask = LVIF_PARAM;
					SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_GETITEM, 0, (LPARAM) &l);
					trans.description = &g_accelMainDescription[l.lParam][0];
					trans.command = pdd->KeytableMain.command[l.lParam];
					if (DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_KEYS), hdlg, KeysDlgProc, (LPARAM) &trans)) {
						pdd->KeytableMain.command[l.lParam] = trans.command;
						l.mask = LVIF_TEXT;
						l.iItem = lpnmitem->iItem;
						if (trans.command.altkey[0].key!=0) {
							l.iSubItem = 1;
							GetKeyString(trans.command.altkey[0].fVirt, trans.command.altkey[0].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 1;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
						if (trans.command.altkey[1].key!=0) {
							l.iSubItem = 2;
							GetKeyString(trans.command.altkey[1].fVirt, trans.command.altkey[1].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 2;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
					}
				}
			}
			return TRUE;

		case WM_DESTROY:
			//pdd->AVSprefs.bAlternateKeys = (IsDlgButtonChecked(hdlg, IDC_REFRESH_KEY)==BST_CHECKED);
			return TRUE;
	}

	return FALSE;
}

static BOOL APIENTRY PreferencesAudioKeyDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hdlg, DWL_USER);

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hdlg, (PrefsDlgData *)lParam);
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETEXTENDEDLISTVIEWSTYLE,
				LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);


			LVCOLUMN c;
			c.mask = LVCF_TEXT|LVCF_WIDTH;
			c.pszText = "Description";
			c.cx = 154;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 0, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Primary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 1, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Secondary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 2, (LPARAM) &c);

			LVITEM l;
			char buffer[255];
			int i;

			for(i=0; i<VDM_ACCEL_AUDIO_COUNT; i++) {
				if (g_accelAudioCommand[i]>-1) {
					l.mask = LVIF_PARAM|LVIF_TEXT;
					l.lParam = i;
					l.iItem = i;
					l.iSubItem = 0;
					l.pszText = &g_accelAudioDescription[i][0];
					int index = SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTITEM, 0, (LPARAM) &l);
					l.mask = LVIF_TEXT;
					l.iItem = index;
					if (pdd->KeytableAudio.command[i].altkey[0].key!=0) {
						l.iSubItem = 1;
						GetKeyString(pdd->KeytableAudio.command[i].altkey[0].fVirt, pdd->KeytableAudio.command[i].altkey[0].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
					if (pdd->KeytableAudio.command[i].altkey[1].key!=0) {
						l.iSubItem = 2;
						GetKeyString(pdd->KeytableAudio.command[i].altkey[1].fVirt, pdd->KeytableAudio.command[i].altkey[1].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
				}
			}

			//CheckDlgButton(hdlg, IDC_REFRESH_KEY, pdd->AVSprefs.bAlternateKeys?BST_CHECKED:BST_UNCHECKED);
			return TRUE;

		case WM_NOTIFY:
			NMHDR *hdr;
			hdr = (LPNMHDR) lParam;
			if (wParam == IDC_LIST_AVS_KEYS) {
				if (hdr->code == NM_DBLCLK) {
					NMITEMACTIVATE *lpnmitem = (LPNMITEMACTIVATE) lParam;
					ACCELKEYSTRANSFER trans;
					LVITEM l;
					l.iItem = lpnmitem->iItem;
					l.iSubItem = 0;
					l.mask = LVIF_PARAM;
					SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_GETITEM, 0, (LPARAM) &l);
					trans.description = &g_accelAudioDescription[l.lParam][0];
					trans.command = pdd->KeytableAudio.command[l.lParam];
					if (DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_KEYS), hdlg, KeysDlgProc, (LPARAM) &trans)) {
						pdd->KeytableAudio.command[l.lParam] = trans.command;
						l.mask = LVIF_TEXT;
						l.iItem = lpnmitem->iItem;
						if (trans.command.altkey[0].key!=0) {
							l.iSubItem = 1;
							GetKeyString(trans.command.altkey[0].fVirt, trans.command.altkey[0].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 1;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
						if (trans.command.altkey[1].key!=0) {
							l.iSubItem = 2;
							GetKeyString(trans.command.altkey[1].fVirt, trans.command.altkey[1].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 2;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
					}
				}
			}
			return TRUE;

		case WM_DESTROY:
			//pdd->AVSprefs.bAlternateKeys = (IsDlgButtonChecked(hdlg, IDC_REFRESH_KEY)==BST_CHECKED);
			return TRUE;
	}

	return FALSE;
}

static BOOL APIENTRY PreferencesCaptureKeyDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hdlg, DWL_USER);

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hdlg, (PrefsDlgData *)lParam);
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETEXTENDEDLISTVIEWSTYLE,
				LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);


			LVCOLUMN c;
			c.mask = LVCF_TEXT|LVCF_WIDTH;
			c.pszText = "Description";
			c.cx = 154;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 0, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Primary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 1, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Secondary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 2, (LPARAM) &c);

			LVITEM l;
			char buffer[255];
			int i;

			for(i=0; i<VDM_ACCEL_CAPTURE_COUNT; i++) {
				if (g_accelCaptureCommand[i]>-1) {
					l.mask = LVIF_PARAM|LVIF_TEXT;
					l.lParam = i;
					l.iItem = i;
					l.iSubItem = 0;
					l.pszText = &g_accelCaptureDescription[i][0];
					int index = SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTITEM, 0, (LPARAM) &l);
					l.mask = LVIF_TEXT;
					l.iItem = index;
					if (pdd->KeytableCapture.command[i].altkey[0].key!=0) {
						l.iSubItem = 1;
						GetKeyString(pdd->KeytableCapture.command[i].altkey[0].fVirt, pdd->KeytableCapture.command[i].altkey[0].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
					if (pdd->KeytableCapture.command[i].altkey[1].key!=0) {
						l.iSubItem = 2;
						GetKeyString(pdd->KeytableCapture.command[i].altkey[1].fVirt, pdd->KeytableCapture.command[i].altkey[1].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
				}
			}

			//CheckDlgButton(hdlg, IDC_REFRESH_KEY, pdd->AVSprefs.bAlternateKeys?BST_CHECKED:BST_UNCHECKED);
			return TRUE;

		case WM_NOTIFY:
			NMHDR *hdr;
			hdr = (LPNMHDR) lParam;
			if (wParam == IDC_LIST_AVS_KEYS) {
				if (hdr->code == NM_DBLCLK) {
					NMITEMACTIVATE *lpnmitem = (LPNMITEMACTIVATE) lParam;
					ACCELKEYSTRANSFER trans;
					LVITEM l;
					l.iItem = lpnmitem->iItem;
					l.iSubItem = 0;
					l.mask = LVIF_PARAM;
					SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_GETITEM, 0, (LPARAM) &l);
					trans.description = &g_accelCaptureDescription[l.lParam][0];
					trans.command = pdd->KeytableCapture.command[l.lParam];
					if (DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_KEYS), hdlg, KeysDlgProc, (LPARAM) &trans)) {
						pdd->KeytableCapture.command[l.lParam] = trans.command;
						l.mask = LVIF_TEXT;
						l.iItem = lpnmitem->iItem;
						if (trans.command.altkey[0].key!=0) {
							l.iSubItem = 1;
							GetKeyString(trans.command.altkey[0].fVirt, trans.command.altkey[0].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 1;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
						if (trans.command.altkey[1].key!=0) {
							l.iSubItem = 2;
							GetKeyString(trans.command.altkey[1].fVirt, trans.command.altkey[1].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 2;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
					}
				}
			}
			return TRUE;

		case WM_DESTROY:
			//pdd->AVSprefs.bAlternateKeys = (IsDlgButtonChecked(hdlg, IDC_REFRESH_KEY)==BST_CHECKED);
			return TRUE;
	}

	return FALSE;
}

static BOOL APIENTRY PreferencesAVSKeyDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam) {
	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hdlg, DWL_USER);

	switch(message) {
		case WM_INITDIALOG:
			PreferencesChildPosition(hdlg, (PrefsDlgData *)lParam);
			SetWindowLong(hdlg, DWL_USER, lParam);
			pdd = (PrefsDlgData *)lParam;

			//////////////
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETEXTENDEDLISTVIEWSTYLE,
				LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);


			LVCOLUMN c;
			c.mask = LVCF_TEXT|LVCF_WIDTH;
			c.pszText = "Description";
			c.cx = 154;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 0, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Primary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 1, (LPARAM) &c);
			c.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
			c.fmt = LVCFMT_CENTER;
			c.pszText = "Secondary Key";
			c.cx = 90;
			SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTCOLUMN, 2, (LPARAM) &c);

			LVITEM l;
			char buffer[255];
			int i;

			for(i=0; i<VDM_ACCEL_AVS_COUNT; i++) {
				if (g_accelAVSCommand[i]>-1) {
					l.mask = LVIF_PARAM|LVIF_TEXT;
					l.lParam = i;
					l.iItem = i;
					l.iSubItem = 0;
					l.pszText = &g_accelAVSDescription[i][0];
					int index = SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_INSERTITEM, 0, (LPARAM) &l);
					l.mask = LVIF_TEXT;
					l.iItem = index;
					if (pdd->KeytableAVS.command[i].altkey[0].key!=0) {
						l.iSubItem = 1;
						GetKeyString(pdd->KeytableAVS.command[i].altkey[0].fVirt, pdd->KeytableAVS.command[i].altkey[0].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
					if (pdd->KeytableAVS.command[i].altkey[1].key!=0) {
						l.iSubItem = 2;
						GetKeyString(pdd->KeytableAVS.command[i].altkey[1].fVirt, pdd->KeytableAVS.command[i].altkey[1].key, (char *) &buffer, 255);
						l.pszText = (char *) &buffer;
						SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
					}
				}
			}

			//CheckDlgButton(hdlg, IDC_REFRESH_KEY, pdd->AVSprefs.bAlternateKeys?BST_CHECKED:BST_UNCHECKED);
			return TRUE;

		case WM_NOTIFY:
			NMHDR *hdr;
			hdr = (LPNMHDR) lParam;
			if (wParam == IDC_LIST_AVS_KEYS) {
				if (hdr->code == NM_DBLCLK) {
					NMITEMACTIVATE *lpnmitem = (LPNMITEMACTIVATE) lParam;
					ACCELKEYSTRANSFER trans;
					LVITEM l;
					l.iItem = lpnmitem->iItem;
					l.iSubItem = 0;
					l.mask = LVIF_PARAM;
					SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_GETITEM, 0, (LPARAM) &l);
					trans.description = &g_accelAVSDescription[l.lParam][0];
					trans.command = pdd->KeytableAVS.command[l.lParam];
					if (DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_KEYS), hdlg, KeysDlgProc, (LPARAM) &trans)) {
						pdd->KeytableAVS.command[l.lParam] = trans.command;
						l.mask = LVIF_TEXT;
						l.iItem = lpnmitem->iItem;
						if (trans.command.altkey[0].key!=0) {
							l.iSubItem = 1;
							GetKeyString(trans.command.altkey[0].fVirt, trans.command.altkey[0].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 1;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
						if (trans.command.altkey[1].key!=0) {
							l.iSubItem = 2;
							GetKeyString(trans.command.altkey[1].fVirt, trans.command.altkey[1].key, (char *) &buffer, 255);
							l.pszText = (char *) &buffer;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) &l);
						} else {
							l.iSubItem = 2;
							SendDlgItemMessage(hdlg, IDC_LIST_AVS_KEYS, LVM_SETITEM, 0, (LPARAM) "");
						}
					}
				}
			}
			return TRUE;

		case WM_DESTROY:
			//pdd->AVSprefs.bAlternateKeys = (IsDlgButtonChecked(hdlg, IDC_REFRESH_KEY)==BST_CHECKED);
			return TRUE;
	}

	return FALSE;
}
// END ***************************************************************

////////////////////////////////////////////////////////////////

static struct prefsTabs {
	LPTSTR	rsrc;
	char	*name;
	DLGPROC	dProc;
} tabs[]={
// ********************************************************************
// *** VirtualDubMod												***
// *** Tobias Minich, Jun 2003										***
// BEGIN **************************************************************
	{	MAKEINTRESOURCE(IDD_PREFS_MOD),		"VDubMod",	PreferencesVDModDlgProc	},
// END ****************************************************************
	{	MAKEINTRESOURCE(IDD_PREFS_MAIN),	"Main",		PreferencesMainDlgProc	},
	{	MAKEINTRESOURCE(IDD_PREFS_DISPLAY),	"Display",	PreferencesDisplayDlgProc },
	{	MAKEINTRESOURCE(IDD_PREFS_SCENE),	"Scene",	PreferencesSceneDlgProc	},
	{	MAKEINTRESOURCE(IDD_PREFS_CPU),		"CPU",		PreferencesCPUDlgProc	},
	{	MAKEINTRESOURCE(IDD_PREFS_AVI),		"AVI",		PreferencesAVIDlgProc	},
// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
//	{	MAKEINTRESOURCE(IDD_PREFS_AVS),		"AVS",		PreferencesAVSDlgProc	},
	{	MAKEINTRESOURCE(IDD_PREFS_KEYS),		"Main Keys",		PreferencesMainKeyDlgProc	},
	{	MAKEINTRESOURCE(IDD_PREFS_KEYS),		"Audio Keys",		PreferencesAudioKeyDlgProc	},
	{	MAKEINTRESOURCE(IDD_PREFS_KEYS),		"Capture Keys",		PreferencesCaptureKeyDlgProc	},
	{	MAKEINTRESOURCE(IDD_PREFS_KEYS),		"Script Editor Keys",		PreferencesAVSKeyDlgProc	},
// END ***************************************************************
};

BOOL APIENTRY PreferencesDlgProc( HWND hDlg, UINT message, UINT wParam, LONG lParam) {

	PrefsDlgData *pdd = (PrefsDlgData *)GetWindowLong(hDlg, DWL_USER);

	//////////

	switch(message) {
		case WM_INITDIALOG:
			{
				RECT r, r2;
				LONG du = GetDialogBaseUnits();
				LONG duX = LOWORD(du);
				LONG duY = HIWORD(du);
				HWND hWndTab = GetDlgItem(hDlg, IDC_TAB);
				LONG xDelta, yDelta;
				POINT p;
				int i;
				char dll_name[MAX_PATH];

				if (!(pdd = new PrefsDlgData)) return FALSE;
				memset(pdd, 0, sizeof pdd);
				SetWindowLong(hDlg, DWL_USER, (LPARAM)pdd);

				pdd->prefs = g_prefs;
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, April 2003											***
// BEGIN **************************************************************
				pdd->m_VDMPrefs = g_VDMPrefs;
				pdd->m_MKVPrefs = g_MKVPrefs;
// END ****************************************************************
// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
//				pdd->AVSprefs = g_AVSprefs;
				pdd->KeytableAVS = g_accelAVS;
				pdd->KeytableCapture = g_accelCapture;
				pdd->KeytableMain = g_accelMain;
				pdd->KeytableAudio = g_accelAudio;
				if (QueryConfigString(NULL, "LanguageDLL", dll_name, MAX_PATH)) { 
					strcpy(pdd->LanguageDLL, dll_name);
				} else {
					pdd->LanguageDLL[0] = 0;
				}
// END ***************************************************************

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, March 2003											***
// BEGIN **************************************************************
				r.left = r.top = 0;
				r.right = /*250*/0;
				r.bottom = /*150*/0;

				RECT tmpRect;

				for(i=0; i<(sizeof tabs/sizeof tabs[0]); i++) {
					TC_ITEM ti;

					ti.mask		= TCIF_TEXT;
					ti.pszText	= tabs[i].name;

					TabCtrl_InsertItem(hWndTab, i, &ti);

					HWND tmpWnd = CreateDialog(g_hInst, tabs[i].rsrc, hDlg, NULL);
					if(tmpWnd) {
						GetWindowRect(tmpWnd, &tmpRect);
						if((tmpRect.right-tmpRect.left)>r.right)
							r.right = tmpRect.right-tmpRect.left;
						if((tmpRect.bottom-tmpRect.top)>r.bottom)
							r.bottom = tmpRect.bottom-tmpRect.top;
						DestroyWindow(tmpWnd);
					}
				}

				//MapDialogRect(hDlg, &r);
// END ****************************************************************

				GetWindowRect(hWndTab, &r2);
				p.x = r2.left;
				p.y = r2.top;
				ScreenToClient(hDlg, &p);
				pdd->rcTab = r;

				TabCtrl_AdjustRect(hWndTab, TRUE, &r);
				OffsetRect(&pdd->rcTab, p.x-r.left, p.y-r.top);

				xDelta = (r.right-r.left) - (r2.right-r2.left);
				yDelta = (r.bottom-r.top) - (r2.bottom-r2.top);

				SetWindowPos(hWndTab, NULL, 0, 0, r.right-r.left, r.bottom-r.top, SWP_NOMOVE|SWP_NOACTIVATE|SWP_NOZORDER);

				guiOffsetDlgItem(hDlg, IDC_SAVE, xDelta, yDelta);
				guiOffsetDlgItem(hDlg, IDOK, xDelta, yDelta);
				guiOffsetDlgItem(hDlg, IDCANCEL, xDelta, yDelta);

				GetWindowRect(hDlg, &r);
				SetWindowPos(hDlg, NULL, 0, 0, r.right-r.left + xDelta, r.bottom-r.top + yDelta, SWP_NOMOVE|SWP_NOACTIVATE|SWP_NOZORDER);

				pdd->hwndDisplay = CreateDialogParam(g_hInst, tabs[0].rsrc, hDlg, tabs[0].dProc, (LPARAM)pdd);
			}
			return TRUE;

		case WM_DESTROY:
			if (pdd) {
				delete pdd;
				SetWindowLong(hDlg, DWL_USER, 0);
			}
			return TRUE;

		case WM_NOTIFY: {
			NMHDR *nm = (LPNMHDR)lParam;

			switch(nm->code) {
			case TCN_SELCHANGE:
				{
					int iTab = TabCtrl_GetCurSel(nm->hwndFrom);

					if (iTab>=0) {
						if (pdd->hwndDisplay) DestroyWindow(pdd->hwndDisplay);
						pdd->hwndDisplay = CreateDialogParam(g_hInst, tabs[iTab].rsrc, hDlg, tabs[iTab].dProc, (LPARAM)pdd);
					}
				}
				return TRUE;
			}
			}break;

	    case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDC_SAVE:
			case IDOK:
				if (pdd->hwndDisplay) {
					DestroyWindow(pdd->hwndDisplay);
					pdd->hwndDisplay = NULL;
				}
				g_prefs = pdd->prefs;
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, April 2003											***
// BEGIN **************************************************************
				g_VDMPrefs = pdd->m_VDMPrefs;
				g_MKVPrefs = pdd->m_MKVPrefs;
// END ****************************************************************
// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
				if (pdd->LanguageDLL[0] != 0) I18N_LoadLibrary(pdd->LanguageDLL);
				g_accelAVS = pdd->KeytableAVS;
				g_accelCapture = pdd->KeytableCapture;
				g_accelMain = pdd->KeytableMain;
				g_accelAudio = pdd->KeytableAudio;
				DestroyAcceleratorTable(g_hAccelAVS);
				g_hAccelAVS = CreateAVSAccelerators();
				DestroyAcceleratorTable(g_hAccelMain);
				g_hAccelMain = CreateMainAccelerators();
				DestroyAcceleratorTable(g_hAccelAudio);
				g_hAccelAudio = CreateAudioAccelerators();
				g_projectui->RebuildMainMenu();
// END ***************************************************************

				if (LOWORD(wParam) == IDC_SAVE) {
					SetConfigBinary("", g_szMainPrefs, (char *)&g_prefs, sizeof g_prefs);
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, April 2003											***
// BEGIN **************************************************************
					SetConfigBinary("", g_szVDubModPrefs, (char *)&g_VDMPrefs, sizeof g_VDMPrefs);
					SetConfigBinary("", g_szMatroskaPrefs, (char *)&g_MKVPrefs, sizeof g_MKVPrefs);
// END ****************************************************************
// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
//					SetConfigBinary("", g_szAVSPrefs, (char *)&g_AVSprefs, sizeof g_AVSprefs);
					SetConfigBinary("", g_szKeytableAVS, (char *)&g_accelAVS, sizeof g_accelAVS);
					SetConfigBinary("", g_szKeytableCapture, (char *)&g_accelCapture, sizeof g_accelCapture);
					SetConfigBinary("", g_szKeytableMain, (char *)&g_accelMain, sizeof g_accelMain);
					SetConfigBinary("", g_szKeytableAudio, (char *)&g_accelAudio, sizeof g_accelAudio);
					SetConfigString("", "LanguageDLL", pdd->LanguageDLL);
// END ***************************************************************
				}

				EndDialog(hDlg, TRUE);
				return TRUE;
			case IDCANCEL:
				if (pdd->hwndDisplay) {
					DestroyWindow(pdd->hwndDisplay);
					pdd->hwndDisplay = NULL;
				}
				EndDialog(hDlg, FALSE);
				return TRUE;
			}
            break;

		case WM_HELP:
			{
				HELPINFO *lphi = (HELPINFO *)lParam;

				if (lphi->iContextType == HELPINFO_WINDOW)
					VDShowHelp(hDlg, L"d-preferences.html");
			}
			return TRUE;
	}

	return FALSE;
}

void LoadPreferences() {
	DWORD dwSize;
	Preferences prefs_t;

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, March 2003											***
// BEGIN **************************************************************
	dwSize = QueryConfigBinary("", g_szMainPrefs, (char *)&prefs_t, sizeof prefs_t, true);
// END ****************************************************************
	if (dwSize) {
		if (dwSize > sizeof g_prefs) dwSize = sizeof g_prefs;

		memcpy(&g_prefs, &prefs_t, dwSize);
	}

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, April 2003											***
// BEGIN **************************************************************
	VDubModPreferences vdmPrefs;
	dwSize = QueryConfigBinary("", g_szVDubModPrefs, (char *)&vdmPrefs, sizeof vdmPrefs, true);
	if(dwSize) {
		if(dwSize > sizeof g_VDMPrefs)
			dwSize = sizeof g_VDMPrefs;
		memcpy(&g_VDMPrefs, &vdmPrefs, dwSize);
	}

	MatroskaPreferences mkvPrefs;
	dwSize = QueryConfigBinary("", g_szMatroskaPrefs, (char *)&mkvPrefs, sizeof mkvPrefs, true);
	if(dwSize) {
		if(dwSize > sizeof g_MKVPrefs)
			dwSize = sizeof g_MKVPrefs;
		memcpy(&g_MKVPrefs, &mkvPrefs, dwSize);
	}
// END ****************************************************************

// *******************************************************************
// *** REFRESH + AVS Modification								   ***
// *** Tobias Minich, August 2002								   ***
// BEGIN *************************************************************
/*	AVSPreferences AVSprefs_t;

	dwSize = QueryConfigBinary("", g_szAVSPrefs, (char *)&AVSprefs_t, sizeof AVSprefs_t);

	if (dwSize) {
		if (dwSize > sizeof g_AVSprefs) dwSize = sizeof g_AVSprefs;

		memcpy(&g_AVSprefs, &AVSprefs_t, dwSize);
	}
*/
	ACCELKEYTABLE_AVS KeytableAVS_t;

	dwSize = QueryConfigBinary("", g_szKeytableAVS, (char *)&KeytableAVS_t, sizeof KeytableAVS_t);

	if (dwSize) {
		if (dwSize > sizeof KeytableAVS_t) dwSize = sizeof KeytableAVS_t;

		memcpy(&g_accelAVS, &KeytableAVS_t, dwSize);
	}

	ACCELKEYTABLE_CAPTURE KeytableCapture_t;

	dwSize = QueryConfigBinary("", g_szKeytableCapture, (char *)&KeytableCapture_t, sizeof KeytableCapture_t);

	if (dwSize) {
		if (dwSize > sizeof KeytableCapture_t) dwSize = sizeof KeytableCapture_t;

		memcpy(&g_accelCapture, &KeytableCapture_t, dwSize);
	}

	ACCELKEYTABLE_MAIN KeytableMain_t;

	dwSize = QueryConfigBinary("", g_szKeytableMain, (char *)&KeytableMain_t, sizeof KeytableMain_t);

	if (dwSize) {
		if (dwSize > sizeof KeytableMain_t) dwSize = sizeof KeytableMain_t;

		memcpy(&g_accelMain, &KeytableMain_t, dwSize);
	}

	ACCELKEYTABLE_AUDIO KeytableAudio_t;

	dwSize = QueryConfigBinary("", g_szKeytableAudio, (char *)&KeytableAudio_t, sizeof KeytableAudio_t);

	if (dwSize) {
		if (dwSize > sizeof KeytableAudio_t) dwSize = sizeof KeytableAudio_t;

		memcpy(&g_accelAudio, &KeytableAudio_t, dwSize);
	}

	DubPerfOptions PerfOptions_t;

	dwSize = QueryConfigBinary("", g_szPerformanceOptions, (char *)&PerfOptions_t, sizeof PerfOptions_t);

	if (dwSize) {
		if (dwSize > sizeof PerfOptions_t) dwSize = sizeof PerfOptions_t;

		memcpy(&g_dubOpts.perf, &PerfOptions_t, dwSize);
	}
// END ***************************************************************
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, March 2003											***
// BEGIN **************************************************************
	g_dubOpts.video.mode = g_VDMPrefs.m_DefaultVideoMode;
	g_dubOpts.video.fShowInputFrame = !!g_VDMPrefs.m_bShowInputFrame;
	g_dubOpts.video.fShowOutputFrame = !!g_VDMPrefs.m_bShowOutputFrame;
	if(g_VDMPrefs.m_AVIRevListsLimit == 0)
		g_VDMPrefs.m_AVIRevListsLimit = 250;
// END ****************************************************************
}
