#include <stdafx.h>
#include <vd2/Dita/resources.h>

namespace {

	// The IDs below are deliberately not exposed via a header file to avoid having to recompile
	// the entire app when editing strings.

	enum { kVDST_Dub = 1 };

	const char *const g_strtab_Dub[]={
		"Dub: Output segment overflow occurred -- segment byte size may be too low.",
		"Dub: Switching to new segment.",
		"Dub: I/O thread has not cycled for ten seconds -- possible livelock. (Thread location: %p)",
		"Dub: Processing thread has not cycled for ten seconds -- possible livelock. (Thread location: %p)",
		"Dub: Video codec produced delay frame while trying to flush codec B-frame delay! Ignoring to avert possible infinite loop.",
		"Dub: Video codec is requesting B-frame delay %d frames longer than end of video! Stopping video stream to avert possible infinite loop.",
		0
	};

	enum { kVDST_AVIReadHandler = 2 };

	const char *const g_strtab_AVIReadHandler[]={
		"AVI: Avisynth detected. Extended error handling enabled.",
		"AVI: OpenDML hierarchical index detected on stream %d.",
		"AVI: Index not found or damaged -- reconstructing via file scan.",
		"AVI: Invalid chunk detected at %lld. Enabling aggressive recovery mode.",
		"AVI: Invalid block found at %lld -- disabling streaming.",
		"AVI: Stream %d has an invalid sample rate. Substituting %lg samples/sec as a placeholder.",
		"AVI: Palette changes detected. These are not currently supported -- color palette errors may appear in the output.",
		0
	};

	enum { kVDST_VideoSource = 3 };

	const char *const g_strtab_VideoSource[]={
		"AVI: Resuming normal decoding (concealment off) at frame %u",
		"AVI: Decoding error on frame %u -- attempting to bypass.",
		"AVI: Frame %u is too short (%d < %d bytes) but decoding anyway.",
		"Video codec \"%.64hs\" is buggy and returned to VirtualDub with MMX active. Applying workaround.",
		"AVI: Video format structure in file is abnormally large (%d bytes > 16K). Truncating to %d bytes.",
		"One of the video codecs installed in the system modified the video format passed to it by VirtualDub.  This indicates a codec "
			"bug that may cause the Windows video codec system to malfunction.",
		0
	};

	enum { kVDST_InputFileAVI = 4 };

	const char *const g_strtab_InputFileAVI[]={
		"AVI: Opening file \"%ls\"",
		"AVI: Keyframe flag reconstruction was not specified in open options and the video stream "
							"is not a known keyframe-only type.  Seeking in the video stream may be extremely slow.",
		"AVI: Type-1 DV file detected -- VirtualDub cannot extract audio from this type of interleaved stream.",
		0
	};

	enum { kVDST_Mpeg = 5 };

	const char *const g_strtab_Mpeg[]={
		"MPEGAudio: Concealing decoding error on frame %lu: %hs.",
		"MPEG: Opening file \"%ls\"",
		"MPEG: Anachronistic or discontinuous timestamp found in %ls stream %d at byte position %lld, from %lld to %lld. This may indicate an improper join.",
		"MPEG: File ended unexpectedly during parsing -- file may be damaged or incomplete.",
		"MPEG: Unknown frame rate code (%d)",
		0
	};

	enum { kVDST_AudioSource = 6 };

	const char *const g_strtab_AudioSource[]={
		"AVI: Truncated or invalid MP3 audio format detected (%d bytes, should be %d). Attempting to fix.",
		0
	};

	enum { kVDST_ProjectUI = 7 };

	const char *const g_strtab_ProjectUI[]={
		"%s",
		"%s - [%s]",
		"%s - [%s] (render in progress)",
		0
	};

// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, June 2003											***
// BEGIN **************************************************************
	enum { kVDST_ModVideoSource = 150 };

	const char *const g_strtab_ModVideoSource[]={
		"Couldn't locate decompressor for format '%c%c%c%c' (%hs).\nVirtualDub requires a Video for Windows (VFW) compatible codec to decompress video. DirectShow codecs, such as those used by Windows Media Player, are not suitable. Only 'Direct stream copy' is available for this video.",
		0
	};

	enum { kVDST_MatroskaReadHandler = 151 };

	const char *const g_strtab_MatroskaReadHandler[]={
		"MKV: Subtitle stream (%d) contains overlapping subtitles. Some of them may not be kept when editing.",
		"MKV: Video frames seems to be weirdly ordered.",
		"MKV: Error while reading data, seeked on wrong block.\nPosition %llu expected, %llu (Block time : %llu) found.",
		"MKV: Error while reading data, seeked to wrong position in file (no Block found).",
		"MKV: Error while reading, seeked on wrong Cluster.",
		"MKV (libebml/libmatroska message): %hs.",
		"MKV: A subtitle of stream %d had no duration.",
		"MKV: A block of stream %d had no time code.",
		"MKV: A frame of stream %d (at %llu ms) had only a forward reference (maybe broken file).",
		"MKV: The video may have a variable framerate. If so we strongly advise you to use another tool to safely process your file.",
		0
	};

	enum { kVDST_MatroskaOutputFile = 152 };
	
	const char *const g_strtab_MatroskaOutputFile[]={
		"MKV: A B-Frame was sent while none was announced during initialization.\nUnhandled.",
		"MKV: Some (%d) B-Frames were waiting for their second frame reference.\nFrames not written in the output file.",
		"MKV: Critical error -> absolute timecode (%llu) in stream %d exceeds current cluster timecode range (base timecode : %llu).",
		"MKV: Not enough space reserved (%lu bytes) at the beginning of the file for the KaxSeekHead. Writing one at the end of the file.",
		"MKV: Guess it's not your lucky day. There wasn't enough space reserved for a KaxSeekHead at the beginning of the file to reference the one written at the end of the file.\nIt's over? Really? The light at the end of the tunnel is almost here. Um... Do you hear a train? Splat!!!",
		0
	};

	enum { kVDST_OGMReadHandler = 153 };

	const char *const g_strtab_OGMReadHandler[]={
		"OGM: Some errors were found while parsing the file.\nPlease see the report for more information ('Streams -> Report').",
		0
	};

	enum { kVDST_TextSourceSRT = 154 };

	const char *const g_strtab_TextSourceSRT[]={
		"SRT: Some errors were found while parsing the file.\nPlease see the report for more information ('Streams -> Report').",
		0
	};

	enum { kVDST_AudioSourceMPA = 155 };

	const char *const g_strtab_AudioSourceMPA[]={
		"MPA: The '%s' information isn't constant.",
		"MPA: This Mpeg-Audio file (not Layer-III) appears to be VBR. I don't like that :p",
		0
	};
// END ****************************************************************
}

void VDInitAppStringTables() {
	VDLoadStaticStringTableA(0, kVDST_Dub, g_strtab_Dub);
	VDLoadStaticStringTableA(0, kVDST_AVIReadHandler, g_strtab_AVIReadHandler);
	VDLoadStaticStringTableA(0, kVDST_VideoSource, g_strtab_VideoSource);
	VDLoadStaticStringTableA(0, kVDST_InputFileAVI, g_strtab_InputFileAVI);
	VDLoadStaticStringTableA(0, kVDST_Mpeg, g_strtab_Mpeg);
	VDLoadStaticStringTableA(0, kVDST_AudioSource, g_strtab_AudioSource);
	VDLoadStaticStringTableA(0, kVDST_ProjectUI, g_strtab_ProjectUI);
// ********************************************************************
// *** VirtualDubMod												***
// *** Cyrius, June 2003											***
// BEGIN **************************************************************
	VDLoadStaticStringTableA(0, kVDST_ModVideoSource, g_strtab_ModVideoSource);
	VDLoadStaticStringTableA(0, kVDST_MatroskaReadHandler, g_strtab_MatroskaReadHandler);
	VDLoadStaticStringTableA(0, kVDST_MatroskaOutputFile, g_strtab_MatroskaOutputFile);
	VDLoadStaticStringTableA(0, kVDST_OGMReadHandler, g_strtab_OGMReadHandler);
	VDLoadStaticStringTableA(0, kVDST_TextSourceSRT, g_strtab_TextSourceSRT);
	VDLoadStaticStringTableA(0, kVDST_AudioSourceMPA, g_strtab_AudioSourceMPA);
// END ****************************************************************
}
